IMPORT TypeOppC
IMPORT GraphClassOppC

EXPORT ISSECTION
EXPORT ISENDSECTION
EXPORT IS_C_NAME
EXPORT IS_C_OPP
EXPORT IS_IF_ELSE
EXPORT CPY_KW_TO_TEST;
EXPORT CPY_STR_TO_TEST
EXPORT COMBACK
EXPORT ISDEBCOM
EXPORT ISENDCOM
EXPORT ISDEBSTRING
EXPORT ISENDSTRING
EXPORT IS_NUMERIC
EXPORT FAST_CHARCPY
EXPORT FAST_CHARCMP
EXPORT FAST_CHARNCP
EXPORT FAST_CHARMEMCPY
EXPORT FAST_CHARNCPY
EXPORT TESTESCCAR
 TEXT

;---------------------------- ISSECTION ------------------------
;ACTION: compare les caracteres de la chaine pointee par A0 avec un 
;        tableau de chaines de references, et si il est trouve une
;        egalite il est retourne la taille de la chaine et son indice
;        dans le tableau de reference.
;ENTREE: A0 pointe sur le texte  tester
;        A1 pointe sur le tableau de structure de chaines de reference
;        A2 pointe sur un int indice trouv dans le tableau de chaines
;        D0 ofset  ajouter pour aller  la chaine suivante du tableau
;        D1 pointe sur adresse indice chaine
;SORTIE: D0 longueur de la chaine de debut de section si trouvee
;       4(A7) indice de la chaine trouve.
;APPEL  C: int ISSECTION(char *str, char *ref_str, int ofs_refstr, long pt_id_find_refstr);
;       ref_str + 33 --> flag Maj/Min
ISSECTION:
   MOVE.L D2,-(A7)
   MOVE.L D1,-(A7)
   MOVEQ #0,D1           ;compte l'indice du tableau de chaine
TestStr:
   MOVE.L A0,-(A7)       ;sauver le pointeurs de chaine
   MOVE.L A1,-(A7)       ;sauver le pointeurs de chaine
   BTST.B  #1,34(A1)     ;tester flag Maj/Min
   BNE BoucleTestMajStr  ;si positionn evaluer Majuscule et minuscules.
   ;.......... tenir compte de Maj/Min ......................
   BoucleTestStr:
     cmp.b(a0)+,(a1)+
     bne NextTestStr     ; SI pas egales test de la chaine suivante
     cmp.b #0,(a1)       ; SI Egal et fin de chaine de test c'est qu'on a trouv
     beq EgalTestStr     ;    ---> Sortir
                         ; SI Egal mais pas fin du test 
     bra BoucleTestStr   ;    ---> continuer test
     
   ;.......... ne pas tenir compte de Maj/Min ..............
   ;           si Majtransformer en minuscules
   BoucleTestMajStr:
     move.b (a0)+,D2
     CMP.b #'@',D2
     BLS CompareTxt      ; branche si dest (a0) est inf ou egal  srce '@'
     CMP.b #'Z',D2
     BHI CompareTxt      ; branche si dest (a0) est superieure  srce 'Z'
       BSET.B #5,D2      ; transformer en minuscule
CompareTxt:
     cmp.b (a1)+,D2
     bne NextTestStr     ; SI pas egales test de la chaine suivante
     cmp.b #0,(a1)       ; SI Egal et fin de chaine de test c'est qu'on a trouv
     beq EgalTestStr     ;    ---> Sortir
                         ; SI Egal mais pas fin du test 
     bra BoucleTestMajStr;    ---> continuer test
   
NextTestStr:
   MOVE.L (A7)+,A1   ;recuperer le pointeurs de chaine initial
   MOVE.L (A7)+,A0   ;recuperer le pointeurs de chaine initial
   BTST.B  #2,34(A1)     ;tester flag derniere section
   BNE PasTrouveStrBegSection  ;si positionn cassos
   ADD.L D0,A1       ;ajouter ofset pour pointer sur chaine de test suivante
   cmp.b #0,(a1)     ;Si fin de la zone de chaine de test cassos
   beq PasTrouveStrBegSection
   ADDQ #1,D1        ;indice suivant
   BRA TestStr       ;Sinon on reteste
  
   
PasTrouveStrBegSection:
   moveq #0,d0
   MOVE.L (A7)+, D1
   MOVE.L (A7)+, D2
   rts;
   
EgalTestStr:
    MOVE.L A1,D0
    MOVE.L (A7)+,A1
    MOVE.L (A7)+,A0
    SUB.L  A1,D0
    MOVE.L (A7)+, A0    ;recuperer adresse de sortie
    MOVE.W D1,(A0);     ;retourner indice de la structure correspondant  cette chaine
    MOVE.L (A7)+, D2
RTS

;------------------------- ISENDSECTION ---------------------------
; ENTREE: D0 esc_car    contient le caractre echapement 
;         A0 str
;         A1 str_ref
;int  ISENDSECTION(int esc_car, char *str, char *str_ref)
;       ref_str + 16 --> flag Maj/Min
ISENDSECTION:
   MOVE.L D1,-(a7)
   MOVE.L A0,-(a7)

;....... ce test n'est jamais fait car le parseur ............
;        sort chaque fois qu'il rencontre CRLF
;        donc il est fait  la fin de la routine de parse
;   BTST.B  #2,17(A1)            ;tester flag EOL
;   BNE PasTestEOLEndSectionCmp  ;si non positionn, au suivant .
;       MOVE.L A2,-(a7)
;       MOVE.L A0,A2             ;sauver position initiale A0 
;       CMP.b #13,(A2)
;       bne TestLFEndSectionCmp
;       CMP.b #10,1(A2)
;       bne  Egal_CR_EndSectionCmp
;       bra  Egal_CRLF_EndSectionCmp
;       
;     TestLFEndSectionCmp:
;       CMP.b #10,(A2)
;       beq  Egal_LF_EndSectionCmp
;       MOVE.L (a7)+,A2
       
       
;PasTestEOLEndSectionCmp:
   BTST.B  #1,17(A1)     ;tester flag Maj/Min
   BNE BoucleEndMajSectionCmp  ;si positionn evaluer Majuscule et minuscules.
   ;.......... tenir compte de Maj/Min ......................
   BoucleEndSectionCmp:
     CMP.b #0,(a0)
     beq EndSectionTestIfRefEgal
     CMP.b (a0)+,(a1)+
     beq BoucleEndSectionCmp
     bra SuiteTestSectionEnd
   ;.......... tenir compte de Maj/Min ......................
   BoucleEndMajSectionCmp:
     CMP.b #0,(a0)
     beq EndSectionTestIfRefEgal
     move.b (a0)+,D1
     CMP.b #'@',D1
     BLS CompareEndTxt      ; branche si dest (a0) est inf ou egal  srce '@'
     CMP.b #'Z',D1
     BHI CompareEndTxt      ; branche si dest (a0) est superieure  srce 'Z'
       BSET.B #5,D1         ; transformer en minuscule
CompareEndTxt:
     CMP.b (a1)+,D1
     beq BoucleEndMajSectionCmp

SuiteTestSectionEnd:
   cmp.b #0,-1(a1)
   beq EndSectionTrouve  ; aller teste si un caractere escape n'annule pas la trouvaille
   bra EndSectionIsEsc
EndSectionTestIfRefEgal: ; Si srce == 0; tester si dest == 0 et si oui srce==dest;
   CMP.b #0, (a1)
   beq EndSectionTrouve0
   
EndSectionIsEsc:      ;
   MOVE.L (A7)+,A0
   MOVE.L (A7)+,D1
   moveq #0,d0
   rts

EndSectionTrouve0:
   ADD.L #1,a0

EndSectionTrouve:  ;  ce point A0 pointe sur der caractere teste.
   CMP.b #0,d0
   beq pas_de_car_esc_a_tester
      MOVE.L (A7),A1  ; recuperer pointeur sur chaine initiale
      bcle_TestEndSection_esc:        ;decremente a1 tant qu'il pointe sur \ (donc si \\ -> impair)
         SUB #1,A1
         CMP.B (a1),D0      ; comparer avec caractere escape     (donc si \\\ ->pair)
         beq bcle_TestEndSection_esc
      move.l (a7),D0       ; recuperer pointeur initial
      sub.l    A1,D0       ; lui soustraire le pointeur sur dernier escape trouve
      AND.L #$00000001,D0  ; tester parite
      BEQ EndSectionIsEsc  ; SI c'est pair donc caractere escape valide donc pas fin de section

pas_de_car_esc_a_tester:
       move.l a0,d0     ; recuperer fin de position de test de fin de section
       sub.l (a7)+,d0   ; soutraire adresse initiale de faon a avoir nb de car
       subq #1,d0
       MOVE.L (A7)+,D1
       rts              ; retourner ce nombre

;Egal_LF_EndSectionCmp:
;Egal_CR_EndSectionCmp:
;   moveq #1,d0
;   MOVE.L (A7)+,A2
;   MOVE.L (A7)+,A0
;   MOVE.L (A7)+,D1
;   rts
   
;Egal_CRLF_EndSectionCmp:
;   moveq #2,d0
;   MOVE.L (A7)+,A2
;   MOVE.L (A7)+,A0
;   MOVE.L (A7)+,D1
;   rts

;---------------------------- FAST_CHARCPY ------------------------
FAST_CHARCPY:
   move.b (a0)+,(a1)+
   bne.b FAST_CHARCPY
   rts

;---------------------------- FAST_CHARMEMCPY ---------------------
FAST_CHARMEMCPY:
   move.b (a0)+,(a1)+
   subq #1,d0
   bne.w FAST_CHARMEMCPY
   rts

;---------------------------- FAST_CHARNCPY ------------------------
FAST_CHARNCPY:
   move.b (a0)+,(a1)+
   subq #1,d0
   bne.w FAST_CHARNCPY
   MOVE.b #0,(a1)
   rts
;---------------------------- FAST_CHARCMP ------------------------
FAST_CHARCMP:
   MOVE.L A0,D0
   BoucleFastCmp:
     cmp.b (a0)+,(a1)+
     beq BoucleFastCmp
   cmp.b #0,(a1)
   beq FastCmpTrouve
   MOVEQ #0,D0
   rts
   
FastCmpTrouve:
   SUB.L D0,A0
   MOVE.L A0,D0
   rts

;------------------------- NOTESCCAR ------------------------------
;ACTION: retourne TRUE  si ce n'est pas un caractere ESC
;        retourne FALSE si c'est un caractere ESC
NOTESCCAR:             ;decremente a0 tant qu'il pointe sur \ (donc si \\ -> impair)
   MOVE.L A1,-(A7)
   MOVE.L A0, A1
   bcle_test_esc_car:
     SUB #1,A0
     CMP.B (a0),D0           ;                                      (donc si \\\ ->pair)
   beq bcle_test_esc_car
   
   sub.l a0,a1
   move.l a0,d0
   AND.L #$00000001,d0
   move.l(a7)+,a1
   rts
   
;---------------------------- IS_C_NAME ---------------------------
;ACTION: teste si le caractere est du type de ceux permis pour
;        le nom des fonctions et variables du C
;ENTREE A0  pointe sur caractere
;SORTIE D0  1 c'est un caractre type 0<->9 a<->z A<->Z underscore.

IS_C_NAME:
  MOVE.B (A0),D0
  AND.L  #$000000FF,D0
  LEA    TypeVarC,A0
  MOVE.B D0(A0),D0
  RTS
  
;---------------------------- IS_C_OPP ----------------------------
;ACTION: teste si le caractere est du type de ceux utilises par
;        par les operateurs du C
;ENTREE A0  pointe sur caractere
;ENTREE A1  pointe sur table d'operateur
;SORTIE D0  pointe sur classe graphique si c'est un caractre type   &|!*+-/=~^<>%

IS_C_OPP:
  MOVE.B (A0),D0
  cmp.b #62, D0       ; tester si signe >
  beq Is_Sup_Symb
  cmp.b #45, D0       ; tester si signe -
  beq Is_moins_Symb
    AND.L  #$000000FF,D0
    LSL #1,D0
    ;LEA    TypeOppC,A0
    MOVE.W D0(A1),D0
  RTS
  
Is_moins_Symb:
  cmp .b #62,1(A0)  ; tester si signe sup apres   ( -> )
  beq Is_Not_Op
    MOVE.W 90(A1),D0 ;90 = 45*2
    rts   
Is_Sup_Symb:
  cmp .b #45,-(A0)  ; tester si signe moins avant ( -> )
  beq Is_Not_Op
    MOVE.W 124(A1),D0 ;124 = 62*2
    rts
Is_Not_Op:
    moveq #0,d0
    rts
    
;---------------------------- IS_NUMERIC ----------------------------
;ACTION: extrait la valeur numerique
;ENTREE A0  pointe sur le premier caractere
;ENTREE A1  pointe sur table de validite
;SORTIE D0  nombre de caractres de la zone numerique
IS_NUMERIC:
  moveq #0,d0
  move.L A0, -(a7)
  test_IS_NUMERIC:
    MOVE.B (A0)+,D0
    TST.B  D0(A1)
    BNE test_IS_NUMERIC
  sub.l (a7)+,a0
  move.l a0,d0
  subq #1,d0
  RTS
  

    
;---------------------------- IS_IF_ELSE --------------------------
;ACTION: teste si le caractere pointe peut etre le debut du mot
;        else ou if
;ENTREE A0  pointe sur caractere
;SORTIE D0  1 c'est un caractre type   else ou if

IS_IF_ELSE:
  cmp.b #105,(A0)      ; i
  beq If01_possible
  cmp.b #101,(A0)             ;e
  bne Pas_if_else
  cmp.b #108,1(A0)            ;l
  bne Pas_if_else
  cmp.b #115,2(A0)            ;s
  bne Pas_if_else
      moveq #1,d0
      rts
If01_possible:
  cmp.b #102,1(A0)    ; f
  bne Pas_if_else
  cmp.b #0,2(A0)      ; \0
  bne  Pas_if_else
       moveq #1,d0
       rts
Pas_if_else:
       moveq #0,d0
       rts
      
;----------------------- CPY_STR_TO_TEST -----------------------
;ACTION: copie les huit caracteres pointes par A0 (src) dans 
;        A1 (dst) si rencontre caractere appartenant pas  ceux
;        autoriss pour un mot clef, place un zero de fin
;        sinon place le zero de fin au 9me caractere.
;        si neuvieme caractere est un d'un mot clef, alors la
;        chaine etudie ne peut etre un mot clef et il est retourne
;        zero.
;ENTREE: A0 chaine source
;        A1 chaine destination (teste pour mot clef du C)
;        D0  pointe sur table de caracteres valides
;SORTIE: longueur (sans le zero de fin) de la chaine a tester
CPY_KW_TO_TEST:
  MOVE.L #TypeVarC, D0
  
CPY_STR_TO_TEST:
  MOVEM.L D1-D2/A2,-(A7)     ;8+8m =24
  MOVE.L D0,A2               ;A2 pointe sur la chaine de validite
  moveq #0,d0
  
  MOVE.L A1,D2               ;
  MOVEQ #0,d1                ;4
 
  MOVE.B (A0)+,D0            ; (AN),(AN)+=12       (A0)+,D0=8
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;1
  move.b d0,(a1)+            ;                      D0,(An)+=8 -->20
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;2
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;3
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;4
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;5
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;6
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;7
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;8
  move.b d0,(a1)+
 
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;9
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;10
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;11
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;12
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;13
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;14
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;15
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;16
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;17
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;18
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;19
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;20
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;21
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;22
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;23
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;24
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;25
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;26
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;27
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;28
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;29
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;30
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;31
  move.b d0,(a1)+
  
  move.b (A0)+,D0
  CMP.B D0(A2),D1
  beq IS_END_OF_KEYWORD      ;32
  move.b d0,(a1)+
  
    
IS_END_OF_KEYWORD:
  move.b #0,(a1)
  move.l A1,d0  
  SUB.L  D2,d0
  MOVEM.L (A7)+,D1-D2/A2   ;12+8m =28
  rts
 IS_NOT_KEYW_C_TST:
  moveq #0,d0
  MOVEM.L (A7)+,D1-D2/A2   ;12+8m =28
  rts
;---------------------------- COMBACK --------------------------
;ACTION: scanne le texte  pour verifier si on est dans un 
;        commentaire. Si oui retourne 1 si non retourne 0
;ENTREE A0  pointe sur la fin du texte a verifier.
;       A1  pointe sur le debut du texte a verifier.
;SORTIE D0  1 A0 pointe un caractere faisant partie d'un 
;                commentaire 
;           0 A0 pointe un caractere ne faisant pas partie d'un 
;                commentaire 

COMBACK:
  move.l d1,-(a7)
  moveq #1,d1
  moveq #0,d0
  sub.l #1,A0          ;dec de 1 pour >=
BcleCOMBACK:
  CMP.L a0,a1            ;si a1(car)>a0(fin) arreter
  BHI EndCOMBACK
    LSL.W #8,d1        ; /
    move.b (a1)+,d1    ; /*
    cmp.w #'/*',d1     ; /*
    bne CompEndCom
     ADD.W #1,d0
     bra BcleCOMBACK
CompEndCom:
    cmp.w #'*/',d1 
    bne BcleCOMBACK
     SUB.W #1,d0
     bra BcleCOMBACK
EndCOMBACK:   
  move.l (a7)+,d1
  rts
;---------------------------- ISENDCOM --------------------------
;ACTION: teste si le caractre point est une fin de commentaire
;        CAD "*/x" avec x different de "/"
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISENDCOM:
   ;move.l A0,-(a7)
   moveq #0,d0
   cmp.b #'*',(a0)+
   bne pas_end_comment
   cmp.b #'/',(a0)+
   bne pas_end_comment
   cmp.b #'/',(a0)
   beq pas_end_comment
      moveq #1,d0
   pas_end_comment:
   ;move.l (a7)+,A0
   rts
 
;---------------------------- ISDEBCOM --------------------------
;ACTION: teste si le caractre point est un debut de commentaire
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISDEBCOM:
   moveq #0,d0
   cmp.b #'/',(a0)+
   bne pas_deb_comment
   cmp.b #'*',(a0)
   bne pas_deb_comment
      moveq #1,d0
   pas_deb_comment:
   rts
;---------------------------- ISDEBSTRING --------------------------
;ACTION: teste si le caractre point est un debut de chaine
;        CAD  x"  avec x different de \'
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISDEBSTRING:
   ;move.l A0,-(a7)
   moveq #0,d0
   cmp.b #'"',(a0)
   bne pas_deb_string
   cmp.b #'\',-1(a0)       ; \
   beq pas_deb_string
   cmp.b #39,-1(a0)        ; '
   beq pas_deb_string
      moveq #1,d0
   pas_deb_string:
   ;move.l (a7)+,A0
   rts

;---------------------------- ISENDSTRING --------------------------
;ACTION: teste si le caractre point est une fin de chaine
;        CAD  x"  avec x different de \' et pas \\"
;ENTREE A0  pointe sur le texte a verifier.
;SORTIE D0  1 A0 pointe une fin de commentaire 
;           0 A0 pointe pas une fin de commentaire 
ISENDSTRING:
   moveq #0,d0
   cmp.b #'"',(a0)
   bne pas_end_string
   
   ;cmp.b #39,-1(a0)        ; '
   ;beq pas_end_string
   
   cmp.b #'\',-1(a0)        ; \
   beq test_end_string
      
      moveq #1,d0
 pas_end_string:
   rts
   
test_end_string:
   move.l A1,-(A7)
   move.l a0, a1
   
bcle_test_end_string:        ;decremente a1 tant qu'il pointe sur \ (donc si \\ -> impair)
   SUB #1,A1
   CMP.B #'\',(a1)           ;                                      (donc si \\\ ->pair)
   beq bcle_test_end_string
   sub.l a1,a0
   move.l a0,d0
   AND.L #$00000001,d0
   move.l(a7)+,a1
   rts
   
  DATA
  
TypeVarC:  
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,0  ,0  ,0  ,0  ,1 
 dc.b  0  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,1  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 dc.b  0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0  ,0 
 
