/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   EZ_ASCII.C    \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                                                                     */
/* le source C ci-dessous est est celui du module: EZ_ASCII.O          */
/* Gestion d'une boite de saisie d'un code ASCII                       */

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>  

/*--------------------- INCLURE LES DEFINITIONS SYMBOLIQUES ------------*/
/*                      que l'diteur de ressource gnre               */
/*                      lors de la cration de la ressource             */
#include "EZ_EDIT.H"
#include "EZ_EDIT.SYS\EZ_ASCII.H"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
static char *PtAscii = 0;
static int QuitMode  = 0;
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*-------------------------Appartenant au module------------------------*/
/*................ FONCTIONS CALLBACK DE FENETRES ......................*/
CALLBACK WindProcEZ_ASCII(int w_ind, EVNT_O *Evnt);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*----------------------------- WindProcEZ_ASCII -------------------------*/
/* Gestion de la fenetre associee a la saisie d'un code ASCII             */
CALLBACK WindProcEZ_ASCII(int w_ind, EVNT_O *Evnt)
{int w_h = Windtab[w_ind].w_h;        /* handle my fenetre: Wind_proc_xxx */
 OBJECT *object = GETWINDTREE(w_ind); /* objet racine du dialogue integre */
 int wh_top;                          /* handle fenetre en avant plan     */
 /*.................... recuperer handle fenetre avant plan...............*/
 wind_get( 0, WF_TOP, &wh_top);

 /*..................... EVENEMENT CLAVIER ...............................*/
 if (Evnt->evnt & MU_KEYBD && w_h == wh_top)
    {if ( (Evnt->key&0x00FF) == 13) 
        {SendWindMessage(w_h, WM_MODAL_END,0);
        }
     else 
        {Xform_keybd(w_ind, Evnt);
         ObjcGetTxt(object, EZ_ASCII_CAR)[0] = atoi(ObjcGetTxt(object, EZ_ASCII_SAISIE));
         Wobjc_draw(w_ind,object, EZ_ASCII_CAR, 3, 0);
        }
    }
 /*..................... EVENEMENT SOURIS ................................*/
 if (Evnt->evnt & MU_BUTTON )
    {int ob_ret;
     ob_ret = Xform_button(w_ind, Evnt);  
     switch (ob_ret)
       {case EZ_ASCII_ANNULER:
             SendWindMessage(w_h, WM_MODAL_END,0);  
             object[ob_ret].ob_state &= ~SELECTED; 
             Wobjc_draw(w_ind,object, ob_ret, 3, 0);
             ObjcSetTxt (object, EZ_ASCII_SAISIE, "");
             break;     
       }         
    } /* endif MU_BUTTON  et fenetre au premier plan */
    
 /*..................... EVENEMENT MU_TIMER ...............................*/  
 if (Evnt->evnt & MU_TIMER && w_h==wh_top)  
    {Xform_timer(w_ind, Evnt);
     /*........SI ALTERNATE Relache (sous Magic) fermer fenetre ...........*/
     /* long mult_os;  si Magic: MagX  Si Mint: MiNT  */
     if (QuitMode == K_ALT && 
         !(Kbshift(-1)&K_ALT)
        ) SendWindMessage(w_h, WM_MODAL_END,0);
    }
 /*..................... EVENEMENT MU_MOVE ................................*/  
 if (Evnt->evnt & MU_MOVE)                  Xform_mu_move(w_ind, Evnt);  
 /*..................... EVENEMENT MU_MESAG ...............................*/  
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT:
            {/*...... dans le parametre: Windtab[w_ind].UserPtr ..............*/
            /*        se trouve l'adresse d'un buffer dans lequel se trouve   */
            /*        le caractere avec lequel ALT a ete appuye              */
            /*        En fin de saisie, il doit etre mis dans ce buffer       */
            /*        le caractere correspondant au code ascii saisi          */
             PtAscii   = (char*)Windtab[w_ind].UserPtr;
             if (PtAscii==0)                       return WM_ABORT;
             if (WindDialogConstruct(w_ind, LoadAppliRsc( "EZ_ASCII.RSC", NO_SCALE),  0, 
                                     RSC_DIAL,  Evnt ) == WM_ABORT
                )                                  return WM_ABORT;
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]); 
             object = GETWINDTREE(w_ind);
             /*......... placer le caractre passe en parametre ......*/
             ObjcSetTxt(object, EZ_ASCII_SAISIE, PtAscii);
             ObjcGetTxt(object, EZ_ASCII_CAR)[0] = atoi(PtAscii);
             /*......... curseur texte apres .........................*/
             Windtab[w_ind].DlgVar.PosCursX = 1;
             /*......... Si on rentre par ALT appuy .................*/
             /*          sortir par K_ALT relach                     */
             if (Kbshift(-1) == K_ALT) QuitMode = K_ALT;
             else                      QuitMode = 0;
            }
             break;
                                         
        case WM_DESTRUCT:       /*  (EZGEM message)   */
             /*........... avant destruction placer caractere ............*/
             /*                       saisi                               */
             if (PtAscii) *PtAscii= (char)atoi(ObjcGetTxt (object, EZ_ASCII_SAISIE));
             Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);
             break;
        case WM_MODAL_END:    DestroyWindow(w_h);                              break; 
        case AP_TERM:         SendMessage(WM_MODAL_END);   EZGemRun=-1;        break;     
        case WM_TT_ON_OFF:    SetBulleState(w_h, object);                      break;                                
        case WM_REDRAW:       Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]); break;    
        case WM_BOTTOM:       wind_set(w_h, WF_BOTTOM );                       break;                               
        case WM_TOPPED:       wind_set(w_h, WF_TOP );                          break;        
        case WM_ALLICONIFY:   AllIconify(0L);                                  break;     
        case WM_ICONIFY:      IconifyWindow(w_ind, 0L);                        break;                                                    
        case WM_UNICONIFY:    UnconifyWindow(w_ind);                           break;                                        
        case WM_SIZED:    
        case WM_MOVED:        Xform_moved(w_ind, Evnt);                        break;                                                                                     
       }
    }      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

