/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ BOOKMARK.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE   du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    d'une fenetre de gestion des Bookmarks           */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#include "EZ_EDIT.H"  /* routines d'affichage et de gestion du texte.  */

/*................ inclure les definitions generees par ...............*/
/*                 l'editeur de ressources afin d'utiliser             */
/*                 les symboles plutot que des nombres                 */
#include "EZ_EDIT.SYS\BOOKMARK.RSH"
#include "EZ_EDIT.SYS\EZ_INFO.RSH"
#include "EZ_EDIT.SYS\EZ_TXT.RSH"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
long FindAllOccurInWind(int w_ind, long len_max, int ident);
long IsThisIndexLoaded(TXTED_OB   *TXT_A, char *path, long lig, char **deb, char **end);
char *MakeMessageString(char *dest,
                        char *token, 
                        char *path, char *nom, long len_max, 
                        long lig, long col, char *message);
char PathIndex[MAX_PATH];
char NomIndex[MAX_PATH>>1];
int OFSL = 1;
/*------------------------------ WindProcBookmark ---------------------------*/
CALLBACK WindProcBookmark(int w_ind, EVNT_O *Evnt)
{OBJECT *object = GETWINDTREE(w_ind);
 int        w_h = GETGEMHAND(w_ind);
 int wh_top;                    
 wind_get( 0, WF_TOP, &wh_top);
 if (Evnt->evnt & MU_KEYBD && w_h == wh_top)
    {if (w_h == wh_top ) Xform_keybd(w_ind, Evnt);
    }
 if (Evnt->evnt & MU_BUTTON)
    {int ob_ret         = Xform_button(w_ind, Evnt);    
     int wind_targ      = IsWindExist(CurIDDoc);
     TXTED_OB  *TXT_A  = 0;
     TXT_GFG *ptTxtCfg = 0;
     if (wind_targ>-1 && IS_IDWINDTXT(CurIDDoc)) 
        {TXT_A    = WTXT_A(wind_targ);
         ptTxtCfg = WTXT_CFG(wind_targ);
        }          
     if (ob_ret>-1)
        {int param[8];
         Evnt->evnt &= ~MU_BUTTON;
         switch(ob_ret)
           {case  FIND_DIALOGUE_FIND_RAD_ALL_WIN:
                  object[FIND_DIALOGUE_FIND_BUT_NEXT].ob_flags       |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_NEXT);
                  object[FIND_DIALOGUE_FIND_BUT_PREV].ob_flags       |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_PREV);
                  object[FIND_DIALOGUE_FIND_BUT_GOTODEBUT].ob_flags  |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_GOTODEBUT);
                  object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_flags       &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_TOUT, 1, 0);
                  break;
            case  FIND_DIALOGUE_FIND_RAD_ACTIV:
                  object[FIND_DIALOGUE_FIND_BUT_NEXT].ob_flags       &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_NEXT, 1, 0);
                  object[FIND_DIALOGUE_FIND_BUT_PREV].ob_flags       &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_PREV, 1, 0);
                  object[FIND_DIALOGUE_FIND_BUT_GOTODEBUT].ob_flags  &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_GOTODEBUT, 1, 0);
                  object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_flags       &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_TOUT, 1, 0);
                  break;
            case  FIND_DIALOGUE_FIND_RAD_BLK:
                  object[FIND_DIALOGUE_FIND_BUT_NEXT].ob_flags       |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_NEXT);
                  object[FIND_DIALOGUE_FIND_BUT_PREV].ob_flags       |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_PREV);
                  object[FIND_DIALOGUE_FIND_BUT_GOTODEBUT].ob_flags  |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_GOTODEBUT);
                  object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_flags       &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_TOUT, 1, 0);
                  break;
            case  FIND_DIALOGUE_FIND_RAD_REPERT:
                  object[FIND_DIALOGUE_FIND_BUT_NEXT].ob_flags       |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_NEXT);
                  object[FIND_DIALOGUE_FIND_BUT_PREV].ob_flags       |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_PREV);
                  object[FIND_DIALOGUE_FIND_BUT_GOTODEBUT].ob_flags  |= HIDETREE;
                  SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_BUT_GOTODEBUT);
                  object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_flags       &= ~HIDETREE;
                  Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_BUT_TOUT, 1, 0);
                  break;
            case  FIND_DIALOGUE_GOTO_TXT_F1 :
            case  FIND_DIALOGUE_GOTO_TXT_F2 :
            case  FIND_DIALOGUE_GOTO_TXT_F3 :
            case  FIND_DIALOGUE_GOTO_TXT_F4 :
            case  FIND_DIALOGUE_GOTO_TXT_F5 :
            case  FIND_DIALOGUE_GOTO_TXT_F6 :
            case  FIND_DIALOGUE_GOTO_TXT_F7 :
            case  FIND_DIALOGUE_GOTO_TXT_F8 :
            case  FIND_DIALOGUE_GOTO_TXT_F9 :
            case  FIND_DIALOGUE_GOTO_TXT_F10 :
                  if (TXT_A && ptTxtCfg)
                  {long     param[2];
                   int nf   = ob_ret - FIND_DIALOGUE_GOTO_TXT_F1;
                   if (ptTxtCfg->Bookmark[nf]==-1) break;
                   param[0] = (long)(ptTxtCfg->Bookmark[nf]+TXT_A->ptTxt);  
                   param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
                   ptTxtCfg->FindPos  =  ptTxtCfg->Bookmark[nf];
                   LastHelpPos        = EZ_ED_GETCURPOS(TXT_A);
                   strcpy( LastHelpFic, ptTxtCfg->PathTxt);
                   strcat( LastHelpFic, ptTxtCfg->NomTxt );
                   EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
                   EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
                  }
                  break;       
            case FIND_DIALOGUE_FIND_BUT_GOTODEBUT:
                 if (TXT_A && ptTxtCfg)
                    {long pos     = (long)TXT_A->TabLgnCtx[0].ptTxt;
                     TXT_A->CarPt = 0;
                     *(long*) &param[0] = (long)pos;  
                     *(long*) &param[2] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
                     ptTxtCfg->FindPos  =  pos - (long)TXT_A->ptTxt;
                     LastHelpPos        = EZ_ED_GETCURPOS(TXT_A);
                     strcpy( LastHelpFic, ptTxtCfg->PathTxt);
                     strcat( LastHelpFic, ptTxtCfg->NomTxt );
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_SEL_DEB,  param, 4, TXT_A);
                     *(long*) &param[0] = (long) NextBreakChar((char*)pos, "\n\r");
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_SEL_END,  param, 4, TXT_A); 
                     object[ob_ret].ob_state &= ~SELECTED;  
                     SendObjectRedraw(w_h, object, ob_ret); 
                    }
                 break;
            case FIND_DIALOGUE_BOOK_OK:          /* BOXTEXT dans l'arbre BOOK_SAISIE */
            case FIND_DIALOGUE_BOOK_ALLER:       /* BOXTEXT dans l'arbre BOOK_SAISIE */
                 if (TXT_A && ptTxtCfg)
                    {long pos     = Min( Max(atol(ObjcGetTxt(object,FIND_DIALOGUE_BOOK_SAISIE_TXT))-OFSL,0), TXT_A->NbLgn -1);
                     pos          = (long)TXT_A->TabLgnCtx[pos].ptTxt;
                     TXT_A->CarPt = 0;
                     *(long*) &param[0] = (long)pos;  
                     *(long*) &param[2] = (long)TXT_A;                                      /*  W_G H_G  adresse de l'editeur cible       */
                     LastHelpPos        = EZ_ED_GETCURPOS(TXT_A);
                     strcpy( LastHelpFic, ptTxtCfg->PathTxt);
                     strcat( LastHelpFic, ptTxtCfg->NomTxt );
                     ptTxtCfg->FindPos  =  pos - (long)TXT_A->ptTxt;
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_SEL_DEB,  param, 4, TXT_A);
                     *(long*) &param[0] = (long) NextBreakChar((char*)pos, "\n\r");
                     EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_SEL_END,  param, 4, TXT_A); 
                     object[ob_ret].ob_state &= ~SELECTED;  
                     SendObjectRedraw(w_h, object, ob_ret); 
                    }
                 if (ob_ret== FIND_DIALOGUE_BOOK_ALLER) break;
                 SendWindMessage(w_h, WM_MODAL_END, 0);
                 break;
            case FIND_DIALOGUE_FIND_BUT_TOUT: 
            case FIND_DIALOGUE_FIND_BUT_PREV:      
            case FIND_DIALOGUE_FIND_BUT_NEXT: 
                 /*............. activer le bon onglet d'index ...........*/
                 /*              de la fenetre info                       */
                 if (object[FIND_DIALOGUE_FIND_CHK_MAKELST].ob_state & SELECTED)
                    {int wind_lst   = IsWindExist(W_EZ_INFO);
                     if (wind_lst != -1)
                        {OBJECT *obj = GETWINDTREE(wind_lst);
                         if ( obj[EZ_INFO_ONG_INDEX].ob_flags&HIDETREE )
                            {ActiveOnglet(wind_lst, EZ_INFO_ONG_MASTER, EZ_INFO_ONG_INDEX);
                             ExeAllMessage();
                            }
                        }
                    }
                 if (object[FIND_DIALOGUE_FIND_RAD_ALL_WIN].ob_state &SELECTED)
                    {int wind, ident;
                     long len_max = 0;
                     for (wind=0; wind<MAX_WIND; wind++)
                         {ident = GETWINDIDENT(wind);
                          if (IS_IDWINDTXT(ident)      && 
                              ! (Windtab[wind].w_flag & W_IS_ICON)
                             )
                             {TXT_GFG *ptWTxtCfg =  WTXT_CFG(wind);
                              long len           = strlen(ptWTxtCfg->PathTxt) + strlen(ptWTxtCfg->NomTxt);
                              len_max            = Max( len, len_max); 
                             }
                         } 
                     len_max = Min(len_max, 64);
                     for (wind=0; wind<MAX_WIND; wind++)
                         {ident = GETWINDIDENT(wind);
                          if (IS_IDWINDTXT(ident)      && 
                              ! (Windtab[wind].w_flag & W_IS_ICON)
                             ) 
                             {TXT_GFG *ptWTxtCfg =  WTXT_CFG(wind);
                              TXTED_OB  *TXT_AL  = WTXT_A(wind);                              
                              if (IsFindAnim==0)  TXT_AL->State |= EDIT_HIDE;   
                              FindAllOccurInWind(w_ind, len_max, ident);
                              if (IsFindAnim==0)  
                                 {TXT_AL->State &= ~EDIT_HIDE;  
                                  Wobjc_draw(wind, GETWINDTREE(wind), EZ_TXT_SCLBOX, 1, 0);
                                 }
                              if (IsIndexAnim==0)
                                 {
                                 }
                              ptWTxtCfg->FindFlag &= ~FIND_FUNC;
                             }
                         } /* end for(wind==0; wind<MAX_WIND; wind++) */ 
                    }
                 else
                    {if (IsFindAnim==0)  TXT_A->State |= EDIT_HIDE;   
                     FindAllOccurInWind(w_ind, strlen(ptTxtCfg->PathTxt) + strlen(ptTxtCfg->NomTxt), CurIDDoc);
                     if (IsFindAnim==0)
                        {TXT_A->State &= ~EDIT_HIDE;
                         Wobjc_draw(wind_targ, GETWINDTREE(wind_targ), EZ_TXT_SCLBOX, 1, 0);
                        }
                     ptTxtCfg->FindFlag &= ~FIND_FUNC;
                    }
                 
                 object[ob_ret].ob_state &= ~SELECTED; 
                 SendObjectRedraw(w_h, object, ob_ret);
                 break;

            case FIND_DIALOGUE_FIND_CHK_REPLACE:
                if (object[FIND_DIALOGUE_FIND_CHK_REPLACE].ob_state &SELECTED)
                   {object[FIND_DIALOGUE_FIND_TXT_REPLACE].ob_flags &= ~HIDETREE;
                    object[FIND_DIALOGUE_FIND_STR_CHK_SEL].ob_flags &= ~HIDETREE;
                    SetFocus(w_ind, (EVNT_O*) 3L, object, FIND_DIALOGUE_FIND_TXT_REPLACE);
                   }
                 else
                   {object[FIND_DIALOGUE_FIND_TXT_REPLACE].ob_flags |= HIDETREE;
                    object[FIND_DIALOGUE_FIND_STR_CHK_SEL].ob_flags |= HIDETREE;
                    SetFocus(w_ind, (EVNT_O*) 3L, object, FIND_DIALOGUE_FIND_TXT_TO_FIND);
                   }  
                SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_TXT_REPLACE); 
                SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_STR_CHK_SEL); 
                break;
           } /*end switch(ob_ret)         */
        }  /* endif (ob_ret>-1)          */
    } /* endif (Evnt->evnt & MU_BUTTON) */
 if (Evnt->evnt & MU_TIMER && w_h == wh_top) Xform_timer(w_ind, Evnt);        
 if (Evnt->evnt & MU_MOVE)                   Xform_mu_move(w_ind, Evnt);
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT:
             /*......... charger et integrer la ressource ......*/
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "BOOKMARK.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;     
             /*......... recuperer adresse premier objet .......*/
             /*        (celui recuper en debut de fonction     */
             /*         est invalide car ressource pas encore   */
             /*         intgre)                               */
             object = GETWINDTREE(w_ind);
             ObjcSetTxt(object, FIND_DIALOGUE_BOOK_SAISIE_TXT,"");         
             /*......... activer l'onglet selon ................*/
             /*             flag d'ouverture                    */
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);                           
        case WM_INIT_BOOK:
        case WM_INIT_MARK:
            {TXTED_OB  *TXT_A    = 0;
             TXT_GFG   *ptTxtCfg = 0;
             /*.......... recuperer flag d'ouverture ...........*/
             /*           (determine l'onglet a activer)        */
             int open_flag     = (int)Windtab[w_ind].UserPtr;
             /*.......... recuperer eventuel bloc ..............*/
             /*                du texte                         */
             int wind_targ     = IsWindExist(CurIDDoc);
             int i;
             char *deb_blk, *end_blk;
             deb_blk = end_blk = 0;
             /*......... si flag d'ouverture indefini ...............*/
             /*          le positionner en fonction de               */
             /*          la ressource                                */
             if (open_flag==0)
                {if      (! (object[FIND_DIALOGUE_FIND_ONG_GOTO].ob_flags  & HIDETREE) )        
                     open_flag = FIND_ALLER_A;
                 else if ( !(object[FIND_DIALOGUE_FIND_ONG_FIND].ob_flags  & HIDETREE) &&
                             object[FIND_DIALOGUE_FIND_TXT_REPLACE].ob_flags & HIDETREE
                         )
                     open_flag = FIND_FIND;
                 else
                     open_flag = FIND_REPLACE;
                }
             if (wind_targ>-1 && IS_IDWINDTXT(CurIDDoc)) 
                {TXT_A             = WTXT_A(wind_targ);
                 ptTxtCfg          = WTXT_CFG(wind_targ);
                 ptTxtCfg->FindPos = EZ_ED_GetLigCol(BLK_TXT_MARK, (long*) &deb_blk, (long*)&end_blk, TXT_A) - TXT_A->ptTxt;
                 /*............. initialiser les champs marques .........*/   
                 for (i=0; i<10; i++)
                     {if (ptTxtCfg->Bookmark[i]>-1)
                         {char *txt = (char*) (ptTxtCfg->Bookmark[i]+TXT_A->ptTxt);
                          ObjcSetTxt(object, FIND_DIALOGUE_GOTO_TXT_F1 + i, txt);
                         }    
                      else ObjcSetTxt(object, FIND_DIALOGUE_GOTO_TXT_F1 + i, "");
                     }  /*endfor (i=0; i<10; i++) */
                }  
                
             switch(open_flag)  
              {case FIND_ALLER_A: 
                    open_flag =  FIND_DIALOGUE_FIND_ONG_GOTO;  
                    object[FIND_DIALOGUE_FIND_TXT_REPLACE].ob_flags |= HIDETREE;
                    object[FIND_DIALOGUE_FIND_STR_CHK_SEL].ob_flags |= HIDETREE;
                    object[FIND_DIALOGUE_FIND_CHK_REPLACE].ob_state &= ~SELECTED;
                    ActiveOnglet(w_ind, FIND_DIALOGUE_FIND_ONG_MASTER, open_flag);
                    break;
               case FIND_FIND:    
                    open_flag =  FIND_DIALOGUE_FIND_ONG_FIND; 
                    object[FIND_DIALOGUE_FIND_TXT_REPLACE].ob_flags |= HIDETREE;
                    object[FIND_DIALOGUE_FIND_STR_CHK_SEL].ob_flags |= HIDETREE;
                    object[FIND_DIALOGUE_FIND_CHK_REPLACE].ob_state &= ~SELECTED;
                    ActiveOnglet(w_ind, FIND_DIALOGUE_FIND_ONG_MASTER, open_flag);
                    SetFocus(w_ind, (EVNT_O*) 3L, object, FIND_DIALOGUE_FIND_TXT_TO_FIND);
                    if (deb_blk && end_blk && deb_blk != end_blk && Evnt->pipe[MESG] != WM_INIT_MARK)
                       {char sav         = *end_blk;
                        *end_blk         = 0;                 
                        ObjcSetTxt(object, FIND_DIALOGUE_FIND_TXT_TO_FIND, deb_blk);
                        Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_TXT_TO_FIND, 1, 0);
                        *end_blk         = sav;
                       }
                    break;
               case FIND_REPLACE: 
                    open_flag =  FIND_DIALOGUE_FIND_ONG_FIND;  
                    object[FIND_DIALOGUE_FIND_TXT_REPLACE].ob_flags &= ~HIDETREE;
                    object[FIND_DIALOGUE_FIND_STR_CHK_SEL].ob_flags &= ~HIDETREE;
                    object[FIND_DIALOGUE_FIND_CHK_REPLACE].ob_state |= SELECTED;
                    ActiveOnglet(w_ind, FIND_DIALOGUE_FIND_ONG_MASTER, open_flag); 
                    SetFocus(w_ind, (EVNT_O*) 3L, object, FIND_DIALOGUE_FIND_TXT_TO_FIND);
                    if (deb_blk && end_blk && deb_blk != end_blk  && Evnt->pipe[MESG] != WM_INIT_MARK)
                       {char sav         = *end_blk;
                        *end_blk         = 0;                 
                        ObjcSetTxt(object, FIND_DIALOGUE_FIND_TXT_TO_FIND, deb_blk);
                        Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_TXT_TO_FIND, 1, 0);
                        *end_blk         = sav;
                       }
                    break;
               }
              
             /*........ mis a jour affichage bookmark ........*/ 
             if (ptTxtCfg)
                {char path[MAX_PATH];                 
                 strcpy(path, ptTxtCfg->PathTxt);
                 strcat(path, ptTxtCfg->NomTxt);
                 ObjcSetTxt(object, FIND_DIALOGUE_FIND_TITLE, path);
                }
             else ObjcSetTxt(object, FIND_DIALOGUE_FIND_TITLE, "");
             
             if (Evnt->pipe[MESG] == WM_INIT_MARK)
                {/*SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_TITLE);*/
                 Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_TITLE, 1, 0);
                 if (open_flag == FIND_DIALOGUE_FIND_ONG_GOTO)
                    {WSetCursObEditOff(w_ind, 0);
                     for (i=0; i<10; i++)
                         {Wobjc_draw(w_ind, object, FIND_DIALOGUE_GOTO_TXT_F1 + i, 1, 0);
                          /*SendObjectRedraw(w_h, object, GOTO_TXT_F1 + i);*/
                         }
                     WSetCursObEditOn(w_ind, 0);    
                    } 
                }
             /*........ analyser chaine de parametrage ........*/
             LenFindStr = atoi(TxtPtStrMess[PRM_LEN_FIND_STR]);   
             /*........ mis a jour affichage remplacer ........*/ 
             if (Evnt->pipe[MESG] == WM_INIT_BOOK)
                {SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_TXT_REPLACE);                  
                 SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_STR_CHK_SEL); 
                 Wobjc_draw(w_ind, object, FIND_DIALOGUE_FIND_TITLE, 1, 0);
                 /*SendObjectRedraw(w_h, object, FIND_DIALOGUE_FIND_TITLE);*/
                }
             break;
            }
        case WM_MODAL_END:   
             {int der_wind = GetDerTXT_Wind(w_ind);
              if (der_wind != -1) CloseWindow(w_ind);
              else 
                 {EZGemRun = -1;
                 }
             }
             break;
        case WM_DESTRUCT:       
             Xform_Destruct(w_ind, Evnt);
             RscFicUnLoad(GETWINDRSC(w_ind));
             break; 

       case WM_MARK_CHG:
            {int n_func = Evnt->pipe[X_G];
             char *txt  = (char*)(*(long*)&Evnt->pipe[W_G]);
             int ind    = n_func + FIND_DIALOGUE_GOTO_TXT_F1;
             if ((long)txt==-1)
                  ObjcSetTxt(object, ind, "");   
             else 
                  ObjcSetTxt(object, ind, txt);
             SendObjectRedraw(w_h, object, ind); 
             break;     
            }
        case WM_MOUSEWHEEL:       Xform_WheelButton(w_ind, Evnt, 1);         break;
        case WM_TT_ON_OFF:      
             SetBulleState(w_h, object);
             break;
        case WM_REDRAW: 
             Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);
             break;
        case WM_BOTTOM:     wind_set(w_h, WF_BOTTOM );                       break;
        case WM_TOPPED:     wind_set(w_h, WF_TOP );                          break;
        case WM_CLOSED:     SendWindMessage(w_h, WM_MODAL_END, 0);           break;
        case WM_ALLICONIFY: AllIconify((GRECT*)& Evnt->pipe[X_G]);           break;
        case WM_ICONIFY:    IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]); break;
        case WM_UNICONIFY:  UnconifyWindow(w_ind);                           break;
        case WM_MOVED:      OnWm_moved(w_ind, Evnt);                         break;
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*----------------------- GrepFindAllOccur -------------------------*/
long GrepFindAllOccur(char *path, char *nom)
{long nb_occur = 0;
 MakeInterDepList(path,nom);
 
 return nb_occur;
}

/*----------------------- FindAllOccurInWind -----------------------*/
long FindAllOccurInWind(int w_ind, long len_max, int ident)
{OBJECT    *object  = GETWINDTREE(w_ind);
 int     wind_targ  = IsWindExist(ident);
 int     wind_lst   = IsWindExist(W_EZ_INFO);
 TXTED_OB   *TXT_A  = 0;
 TXT_GFG *ptTxtCfg  = 0;
 long        occur  = 0;
 int    au_suivant  = TRUE;
 long          ret  = 0;
 char buft[MAX_PATH<<1];
 char path[MAX_PATH];
 char *deb, *end, *deb_r, *end_r, *pt;
 char sav;
  
 /*............... recuperer varibles de fenetre ...................*/
 if (wind_targ>-1 && IS_IDWINDTXT(ident)) 
    {TXT_A    = WTXT_A(wind_targ);
     ptTxtCfg = WTXT_CFG(wind_targ);
    }
if (TXT_A==0 || ptTxtCfg == 0) return 0;

{/*.............. recuperer les variables d'edition ................*/
 /*               des saisies chercher, remplace, index             */

 TXTED_OB  *TXT_F = EZ_ED_GetTxtEditStruct(object, FIND_DIALOGUE_FIND_TXT_TO_FIND);
 TXTED_OB  *TXT_R = EZ_ED_GetTxtEditStruct(object, FIND_DIALOGUE_FIND_TXT_REPLACE);
 TXTED_OB  *TXT_L = 0;
 if    (wind_lst != -1) TXT_L = EZ_ED_GetTxtEditStruct(GETWINDTREE(wind_lst), EZ_INFO_BOX);
 
 /*............ positionner le depart de la recherche ..............*/
 /*             et la fin de la recherche                           */
 if (object[FIND_DIALOGUE_FIND_RAD_ALL_WIN].ob_state & SELECTED ||
     object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_state    & SELECTED
    )
     {ptTxtCfg->FindPos  = 0;
      ptTxtCfg->FindEnd  = (long)TXT_A->EndTxt - (long)TXT_A->ptTxt;
     }
 else if (object[FIND_DIALOGUE_FIND_RAD_BLK].ob_state &SELECTED) 
     {long deb,end;
      EZ_ED_GetLigCol(BLK_TXT_MARK, &deb, &end, TXT_A);
      if (deb != end)
         {ptTxtCfg->FindPos = deb - (long)TXT_A->ptTxt;
          ptTxtCfg->FindEnd = end - (long)TXT_A->ptTxt;    
         }
      else return 0;
     }
 else   
     {ptTxtCfg->FindPos  =  EZ_ED_GetLigCol(BLK_TXT_MARK, 0, 0, TXT_A) - TXT_A->ptTxt;
      ptTxtCfg->FindEnd  = (long)TXT_A->EndTxt - (long)TXT_A->ptTxt;
     }
 
 /*............ positionner le type de recherche ...................*/
 if (object[FIND_DIALOGUE_FIND_CHK_MOT].ob_state &SELECTED)
    {ptTxtCfg->FindFlag |=  FIND_WORD;
    }
 else 
    {ptTxtCfg->FindFlag &= ~FIND_WORD;
    } 
 if (object[FIND_DIALOGUE_FIND_CHK_MAJMIN].ob_state &SELECTED)
    {ptTxtCfg->FindFlag |=  FIND_MINMAJ;
    }
 else 
    {ptTxtCfg->FindFlag &= ~FIND_MINMAJ;
    }
  
 /*............ sens recherche ....................................*/
 if (object[FIND_DIALOGUE_FIND_BUT_NEXT].ob_state & SELECTED)
    {ptTxtCfg->FindFlag |= FIND_FORWARD;
    }
 else if (object[FIND_DIALOGUE_FIND_BUT_PREV].ob_state & SELECTED)
    {ptTxtCfg->FindFlag &= ~FIND_FORWARD;
    }   
 else ptTxtCfg->FindFlag |= FIND_FORWARD;
 
 /*............ rechercher toutes les occurence ? .................*/
 if (object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_state & SELECTED) 
    {ptTxtCfg->FindFlag &= ~FIND_LOOP_REVERSE;
     ptTxtCfg->FindFlag |= FIND_LOOP_BREAK;
    }
 else if ( object[FIND_DIALOGUE_FIND_CHK_SENS].ob_state & SELECTED) 
    {ptTxtCfg->FindFlag &= ~FIND_LOOP_REVERSE;
     ptTxtCfg->FindFlag &= ~FIND_LOOP_BREAK;
    }
 else
    {ptTxtCfg->FindFlag |= FIND_LOOP_REVERSE;
     ptTxtCfg->FindFlag &= ~FIND_LOOP_BREAK;
    }
 
 /*........... initialiser boucle de recherche ......................*/
 pt =  TXT_A->ptTxt;
 if (TXT_L)
    {TXT_L->State    &= ~(EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
     TXT_L->State    |=  (EDIT_SCRLH_NOT_AFTER_PASTE);
     if (IsIndexAnim == 0)  TXT_L->State |= (EDIT_HIDE|EDIT_SCRLV_NOT_AFTER_PASTE);
     EZ_ED_GraphUpdate(TXT_L);
    }
 if (IsFindAnim  == 0)  TXT_A->State |= (EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 /*............ mettre  jour le texte ..............................*/
 EZ_ED_GraphUpdate( TXT_A);
 
 /*.......... recuperer le texte a rechercher .......................*/
 EZ_ED_GraphUpdate( TXT_F);
 EZ_ED_GetLigCol(BLK_TXT_MARK, (long*) &deb,   (long*)&end, TXT_F);
 if (deb == end)
    {deb = TXT_F->ptTxt;
     end = TXT_F->EndTxt;
    }
 /*.......... recuperer le texte a remplacer ........................*/
 EZ_ED_GraphUpdate( TXT_R);
 EZ_ED_GetLigCol(BLK_TXT_MARK, (long*) &deb_r, (long*)&end_r, TXT_R);
 if (deb_r == end_r)
    {deb_r = TXT_R->ptTxt;
     end_r = TXT_R->EndTxt;
    }
 /*........... boucle de recherche ..................................*/
 while (au_suivant)
    {if (IsFindAnim)   EZ_ED_GraphUpdate(TXT_A);
     if (TXT_L && IsIndexAnim)  EZ_ED_GraphUpdate( TXT_L);
     /*......si recherche de fonctions les rechercher ...............*/
     if (ptTxtCfg->FindFlag & FIND_FUNC)
        {long param[4];
         ERR_C err    = {0,0};
         char *ptfunc = FindFunc(TXT_A->ptTxt, pt, &pt, &err);
         if (err.Flag) 
            {long lig, col;
             EZ_ED_GetLigCol((size_t) err.pt, &lig, &col, TXT_A);
             MakeMessageString(buft,
                        "Error", 
                        ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, len_max, 
                        lig, col, GetMessageError(err.Flag));
             AddString(wind_lst, buft, TXT_L);
             ptfunc = 0;
            }
         if (ptfunc==0) break;
         param[0] = (long)(ptfunc);
         param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_SEL_DEB,  (int*)param, 4, TXT_A);
         param[0] = (long)(EndOfLine(ptfunc));
         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_SEL_END,  (int*)param, 4, TXT_A);
         
        }
     /*......si recherche d'une occurence la rechercher .............*/
     else   
        {sav     = *end;
         *end    = 0;
         ret     = TxtFind (wind_targ, deb);
         *end    = sav;
        }
     
     if (ret ==-1)   break;
     occur++;
     /*............. si replace remplacer ................*/
     if (object[FIND_DIALOGUE_FIND_CHK_REPLACE].ob_state &SELECTED)
        {/*... borner la reference a remplacer au bloc....*/
         sav       = *end_r;
         *end_r    = 0;  
         if (*deb_r) TxtReplace (wind_targ, deb_r);
         *end_r    = sav;
        }
     /*............. ajouter l'occurence  l'index .......*/
     if (object[FIND_DIALOGUE_FIND_CHK_MAKELST].ob_state & SELECTED)
        {char *pt  = path;
         char sav;
         char *f;
         strcpy(buft,"Found ");
         /*............. D:\ .... PATH\FICHIER.TXT .......*/
         StrPathStrNameToStrPath(buft + strlen(buft), 
                                 ptTxtCfg->PathTxt,
                                 ptTxtCfg->NomTxt,
                                 len_max                                      
                                );
         strcat(buft," ");
         StrNcat(buft, ltoa(TXT_A->LigPt+OFSL,"               ",10),5);
         strcat(buft,": ");
         pt = f = EZ_ED_GetLigCol(BLK_TXT_MARK, 0, 0, TXT_A);
         while(*f && *f != 13 && *f != 10) f++;
         sav = *f;
         *f  = 0;
         StrNcat(buft, pt, LenFindStr); 
         *f  = sav;
         AddString(wind_lst, buft, TXT_L);  
        }
     /*........... tester interruption boucle ............*/
     if ( (object[FIND_DIALOGUE_FIND_BUT_TOUT].ob_state & SELECTED || Mousek()) &&
          !Kbshift(-1)
        ) 
        {au_suivant = TRUE;
        }
     else au_suivant = FALSE;
    } /* endwhile  */
 TXT_A->State &= ~(EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 /*........ si pas d'animation redessiner fenetre index a la fin .........*/
 if (TXT_L) TXT_L->State &= ~(EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 if (IsIndexAnim==0)
     /*......... redessin selon si boite d'index Find/replace ou celle de index/fonctions .........*/
    {if (wind_lst != -1) Wobjc_draw(wind_lst, GETWINDTREE(wind_lst), EZ_INFO_BOX, 1, 0); 
    }   
}
 return occur;
}
/*------------------------ GetMessageError ---------------------------------*/
char *GetMessageError(int error)
{switch(error)
  {case  ACCO_END_NOT_FIND:    return TxtPtStrMess[ERR_ACCO_CLOSE];
   case  ACCO_DEB_NOT_FIND:    return TxtPtStrMess[ERR_ACCO_OPEN];
   case  PARNTH_END_NOT_FIND:  return TxtPtStrMess[ERR_PRTH_CLOSE];
   case  PARNTH_DEB_NOT_FIND:  return TxtPtStrMess[ERR_PRTH_OPEN];
   case  COMMENT_END_NOT_FIND: return TxtPtStrMess[ERR_COMM_CLOSE];
   case  COMMENT_DEB_NOT_FIND: return TxtPtStrMess[ERR_COMM_OPEN];
   case  GUILLM_END_NOT_FIND:  return TxtPtStrMess[ERR_GUILL_CLOSE];
   case  GUILLM_DEB_NOT_FIND:  return TxtPtStrMess[ERR_GUILL_OPEN];
   case  APPOST_END_NOT_FIND:  return TxtPtStrMess[ERR_APPO_OPEN];
   case  APPOST_DEB_NOT_FIND:  return TxtPtStrMess[ERR_APPO_CLOSE];
   case  END_BCONST_NOT_FIND:  return TxtPtStrMess[ERR_BCONST_END];
   case  DEB_BCONST_NOT_FIND:  return TxtPtStrMess[ERR_BCONST_DEB];
   default:                    return TxtPtStrMess[ERR_INCONNUE];
  }
}
/*--------------------- MakeMessageString ----------------------------------*/
char *MakeMessageString(char *dest,
                        char *token, 
                        char *path, char *nom, long len_max, 
                        long lig, long col, char *message)
{/*............. "Found " ..........................*/
 strcpy(dest, token);
 strcat(dest, " ");
 /*............. "D:\ .... PATH\FICHIER.TXT" .......*/
 StrPathStrNameToStrPath(dest + strlen(dest), path, nom, len_max );
 strcat(dest," ");
 /*.............. ": 1230" .........................*/
 StrNcat(dest, ltoa(lig+OFSL,"               ",10),7);
 strcat(dest,": ");
 /*.............. ": 1230" .........................*/
 StrNcat(dest, ltoa(col+OFSL,"               ",10),7);
 strcat(dest,": ");
 /*.............. " message " ......................*/
 StrNcat(dest, message, LenFindStr); 
 return dest;
} 