/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\   EZ_INFO.C    \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* Source C du module gerant la fenetre index/fonctions du programme    */
/* EZ_EDIT. Le fichier projet associ est:          EZ_EDIT.PRJ         */
/*                                                                      */
 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*--------------------- INCLUDES DES AUTRES MODULES DU PROGRAMME -------*/
#include <EAZY_GEM.H>  /* inclure les definitions des fonctions que le  */
                       /* que le module EAZY_GEM.LIB met  votre et     */
                       /* notre disposition                             */
/*--------------------- INCLURE LES DEFINITIONS SYMBOLIQUES ------------*/
/*                      que l'diteur de ressource gnre               */
/*                      lors de la cration de la ressource             */
#include "EZ_EDIT.SYS\EZ_INFO.RSH"
#include "EZ_EDIT.SYS\EZ_TXT.RSH"
#include "EZ_EDIT.H"

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/* il n' y en a pas pour cet exemple !!                                 */
char*      TXT_FUNC     = 0;  /* stockera le composant d'edition des fonctions   */
char*      TXT_INDX     = 0;  /* stockera le composant d'edition des index       */
char*      TXT_MESS     = 0;  /* stockera le composant d'edition des messages    */
char*      TXT_INDP     = 0;  /* stockera le composant d'edition des dependances */
int        OngActif;
CAR_ATTR   ATT_HEAD;
CAR_ATTR   ATT_CLAS;
CAR_ATTR   ATT_INCL;
CAR_ATTR   ATT_WARN;
CAR_ATTR   ATT_FUNC;
CAR_ATTR   ATT_ERRR;
CAR_ATTR   ATT_METH;
int FlagInc             = -1;

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
char *FindFirstSignifiant(char *pt);
long IfThisIncludeExist(TXTED_OB  *TXT_A, char *path, char *nom, char *pt_deb);
long AddIncludeInfo(int w_ind_info, char *path, char *nom, long lig, char *pt, int flag);
void ListerAllDepList(int w_h, OBJECT *object, int ident_in);
int ActiveDependList(TXTED_OB  *TXT_A, int x, int y, int flag);
int BeforeIsOk(char *buft, char *pt_src);
void ListerFonctions(int ident_in);
void EraseAll(int w_ind);
void MemoryPut(int w_ind, char *ptStr);
long FindAllFuncInWind(int wind_src, int len_max, int ident);
int MakeInterDepList(char *path, char *nom);
char *GetNextData(FILE *fh, char *buft, long *pt_data, long *len_buft, char *is_der_buf);
char *FIndPathOfCurentLine(char *deb, char *pt, char *dst);
char *FIndPathOfCurentLineV2(TXTED_OB   *TXT_A, char *pt, char *dst, char *head);
int  TrierFonctions(TXTED_OB  *TXT_A, char *path);
int  LineFuncCompare (const void *one, const void *two);
int  AddFuncList(char *path, char *nom, int flag, char *head, char *mess);
long IsThisFuncListInWind(TXTED_OB   *TXT_A, char *path, long lig, char **deb, char **end, char *head);
void AdjustInfRscToNewGrectWind(long w_attr, OBJECT *object, GRECT *oldGrect,  GRECT *newGrect);
void AdjustSrollInfoSlide(OBJECT *object);
int AfficheInfoLigne(long i, int tx, int ty, TXTED_OB *TXT_A);
int TesteGCCShellInclude(char *nom);
INT16 OnMouseErreur(TXTED_OB  *TXT_A,  EVNT_O *Evnt);
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
 

/*------------------------------ WindProcEZ_INFO ---------------------------*/
CALLBACK WindProcEZ_INFO(int w_ind, EVNT_O *Evnt)
{/*....recuperer l'adresse du premier objet (racine) de la ressource....*/
 OBJECT *object = GETWINDTREE(w_ind); 
 /*.... recuperer handle fenetre avant plan (besoin apres)..............*/
 int wh_top;                    /* handle fenetre en avant plan         */
 /*.................... recuperer handles fenetres ......................*/
 int w_h          = GETGEMHAND(w_ind);  /* celui GEM de notre fenetre    */
 wind_get( 0, WF_TOP, &wh_top); /* recuperer handle fen. avt plan.      */
 /*............................Rpondre  l'vnement MU_KEYBD .........*/
 if (Evnt->evnt & MU_KEYBD && Windtab[w_ind].w_h == wh_top)
    {if (Windtab[w_ind].w_h == wh_top ) Xform_keybd(w_ind, Evnt);
    }
    
 /*.......................... Rpondre  l'vnement MU_BUTTON .........*/ 
 
 if (Evnt->evnt & MU_BUTTON)
    {INT16     ob_ret  = -1;
     INT16     wh_find =  wind_find(Evnt->x,Evnt->y);
     TXTED_OB  *TXT_A  =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
     if (wh_top != w_h && wh_find == w_h)
        { if (OnMouseErreur(TXT_A, Evnt )==-2)  SendWindMessage(w_h, WM_TOPPED, 0);
        }
     else if (wh_top == w_h)
        {if (OnMouseErreur(TXT_A, Evnt ) <= -1)
            {ob_ret = Xform_button(w_ind, Evnt); /* recuperer objet clique */
            }
        }
     else if (WindHandToIndice(wh_find)<MAX_WIND) SendWindMessage(wh_find, WM_TOPPED, 0);
     else Evnt->evnt &= ~MU_BUTTON;
     if (ob_ret>-1)            /*<<<<SI UN OBJET EST CLIQUE >>>>>>>>>>>*/
        {/*.... empecher propagation message  MU_BUTTON ...............*/
         /*     de faon  ce qu'il ne soit pas possible de            */
         /*     cliquer sur deux fenetres  la fois.                   */
         Evnt->evnt &= ~MU_BUTTON;  
         
         /*.......le remettre en non selectionn et le redessiner......*/
         object[ob_ret].ob_state &= ~SELECTED;  
         if (object[ob_ret].ob_type &((G_CICON<<8)|G_USERDEF))
             SendObjectRedraw( w_h, object, ob_ret); 
         else
             Wobjc_draw(w_ind,object, ob_ret, 3, 0);
         
         /*.............. ICI ACTION SELON BOUTON CLIQUE..............*/
         /* j'ai mis en commentaire comment il est possible de tester */
         /* et lancer une action selon l'objet cliqu. Utilisez les   */
         /* symboles du fichier .H de la ressource (ici EZ_INFO.H) afin */
         /* de rendre votre programme plus lisible.                   */
                     
          switch (ob_ret)
            {case EZ_INFO_LOAD_INCLDEF:
             case EZ_INFO_INCL_PATH:
                 {char path[MAX_PATH];
                  char nom[MAX_PATH]; 
                  char *txt;
                  long len    = ObjcGetLenTxt (object, EZ_INFO_INCL_PATH, &txt);
                  strcpy(path,InclPath);
                  strcpy(nom,"");
                  if (FileSelect (path, nom, ".H", TxtPtStrMess[LOAD_INCLPATH]) != -2
                     )
                     {
                      strcpy(InclPath, path);
                      StrPathStrNameToStrPath(txt, InclPath, 0, len -1);
                      SendObjectRedraw( w_h, object, EZ_INFO_INCL_PATH); 
                     }
                 }
                  break;
             case EZ_INFO_UPDATE_INTDEP:
                  ListerAllDepList(w_h, object, CurIDDoc);
                  break;
             case EZ_INFO_UPDATE_ALL_INTDEP:
                  ListerAllDepList(w_h, object, 0);
                  break;
             case EZ_INFO_LOAD_INTDEP:
                 {TXTED_OB  *TXT_L   = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
                  int   wind_targ    = IsWindExist(CurIDDoc);
                  char *pt_ext;
                  char path[MAX_PATH];
                  char nom[MAX_PATH];
                  path[0]  = 0;
                  nom[0]   = 0;
                  /*................ chercher d'abord dans la liste ..................*/
                  if (FIndPathOfCurentLineV2(TXT_L, EZ_ED_GETCURLIG(TXT_L), path, "DEPEND"))
                     {PathNomToNomFic(path, nom);
                     }
                  /*............. puis dans le texte affiche .........................*/
                  if (wind_targ>-1)
                      {TXT_GFG   *ptTxtCfg   = WTXT_CFG(wind_targ);
                       TXTED_OB  *TXT_A      = WTXT_A(wind_targ);
                       if (*nom==0 && *path==0)
                          {strcpy(path, ptTxtCfg->PathTxt);
                           strcpy(nom,  ptTxtCfg->NomTxt);
                          }
                       pt_ext = GetExtension(nom, 0);
                       if (pt_ext==0) pt_ext = ".*";
                       if (TXT_A && ptTxtCfg && 
                           FileSelect (path, nom, pt_ext, TxtPtStrMess[LIST_INCLUDE]) > -2
                          )
                          {FlagInc = 0;
                           AddFuncList(path, nom, INDEX_ADDSTRING, "DEPEND", "  : Inclue les fichiers suivants ");
                           MakeInterDepList( path, nom);
                          }
                      }
                 }
                  break;
             case EZ_INFO_UPDATE:
                  ListerFonctions(CurIDDoc);
                  break;
             case EZ_INFO_UPDATE_ALL:
                  ListerFonctions(0);
                  break;
             case EZ_INFO_LOAD_INDEX:
             case EZ_INFO_LOAD_LOG:
                  {int wind_targ    = IsWindExist(CurIDDoc);
                   char *pt_ext; 
                   char *txtmess;
                   if (wind_targ>-1)
                       {TXT_GFG   *ptTxtCfg     =  WTXT_CFG(wind_targ);                        
                        strcpy(PathTxt, ptTxtCfg->PathTxt);
                        strcpy(NomTxt,  ptTxtCfg->NomTxt);
                        if (ob_ret==EZ_INFO_LOAD_INDEX) pt_ext = ".IND";
                        else                            pt_ext = ".LOG";
                        if (ob_ret==EZ_INFO_LOAD_INDEX) txtmess = TxtPtStrMess[LOAD_INDEX];
                        else                            txtmess = TxtPtStrMess[LOAD_LOGIC];
                        XFilesSelect(PathTxt, NomTxt, pt_ext, txtmess, 1);
                       }
                   }
                  break;
             case EZ_INFO_DELETE_LIST_ALL_00:
             case EZ_INFO_DELETE_LIST_ALL_01:
             case EZ_INFO_DELETE_LIST_ALL_02:
             case EZ_INFO_DELETE_LIST_ALL:
                  EraseAll(w_ind);
                  break;
             case EZ_INFO_DELETE_LIST_IND:
                 {/*.................. version effaant tout ................................*/
                  int param[8]; 
                  TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);   
                  char *deb, *fin;
                  EZ_ED_GraphUpdate(TXT_A);        
                  /*............ noter coordonnes du bloc ..............................*/
                  EZ_ED_GetLigCol(BLK_TXT_MARK, (long*)&deb, (long*)&fin, TXT_A);
                  fin = NextLine(fin);
                  deb = DebOfLine(TXT_A->ptTxt, deb);
                  /*........... effacer le bloc .........................................*/
                  *(long*) &param[2] = (long)TXT_A;                                       
                  EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
                  *(long*) &param[0] = (long)deb;
                  EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,  param, 4, TXT_A);
                  *(long*) &param[0] = (long)fin;
                  EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,  param, 4, TXT_A);
                  EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CUT, param, 4, TXT_A);
                 }
                  break;
              case EZ_INFO_DELETE_LIST_INTDEP:
                  {
                  /*........... version effaant juste la liste d'une fenetre ...............*/
                  TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
                  char path[MAX_PATH];
                  char nom[MAX_PATH];
                  *path = 0;
                  FIndPathOfCurentLineV2(TXT_A,EZ_ED_GETCURLIG(TXT_A), path, "DEPEND");
                  PathNomToNomFic(path, nom);
                  AddFuncList(path, nom, 0, "DEPEND", "  : Inclue les fichiers suivants ");
                 }
                  break;
             case EZ_INFO_DELETE_LIST_LOGOUT:
                 {
                  /*........... version effaant juste la liste d'une fenetre ...............*/
                  TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
                  char path[MAX_PATH];
                  char nom[MAX_PATH];
                  *path = 0;
                  FIndPathOfCurentLineV2(TXT_A,EZ_ED_GETCURLIG(TXT_A), path, "LOADED");
                  PathNomToNomFic(path, nom);
                  AddFuncList(path, nom, 0, "LOADED", "  : Fichier d'index charge par EZ_EDIT ");
                 }
                  break;
             case EZ_INFO_DELETE_LIST:
                 {
                  /*........... version effaant juste la liste d'une fenetre ...............*/
                  TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
                  char path[MAX_PATH];
                  char nom[MAX_PATH];
                  *path = 0;
                  FIndPathOfCurentLineV2(TXT_A,EZ_ED_GETCURLIG(TXT_A), path, "LISTED");
                  PathNomToNomFic(path, nom);
                  AddFuncList(path, nom, 0, "LISTED", "  : Liste des fonctions by EZ_EDIT ");
                 }
                  break;
             case EZ_INFO_TRIER_LIST_ALL:
                 {TXTED_OB  *TXT_A =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
                  char *txt        = 0;
                  char *fin        = 0;
                  char *deb        = 0;
                  long l, len;
                  for (l = 0; l<TXT_A->NbLgn; l++)
                   {txt  = EZ_ED_GETTXT(TXT_A, l, 0);
                    if (strncmp(txt, "LISTED" ,10)==0)
                       {char path[MAX_PATH];
                        deb       = txt + 11;
                        fin       = NextBreakChar(txt + 11, " "); /* se mettre en fin de path */
                        len       = (long) (fin - deb);
                        memcpy(path, deb, len);
                        path[len] = 0;
                        TrierFonctions(EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX), path);
                       } /*endif (strncmp(txt, "LOADED" ,10)==0)  */
                   } /*endfor (l = 0; l<TXT_A->NbLgn; l++)  */
                  Wobjc_draw(w_ind, object, EZ_INFO_BOX, 1, 0);
                 }
                  break;
             case EZ_INFO_TRIER_LIST:
                  TrierFonctions(EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX), 0);
                  Wobjc_draw(w_ind, object, EZ_INFO_BOX, 1, 0); 
                  break;
            }
        }  /* endif objet selectable cliqu  */ 
    } /* endif MU_BUTTON  et fenetre au premier plan */
 
 /*.......................... Rpondre  l'vnement MU_TIMER.............*/
 if (Evnt->evnt & MU_TIMER && Windtab[w_ind].w_h == wh_top)  
    {Xform_timer(w_ind, Evnt);    
    }
   
 /*..........................Rpondre  l'vnement MU_MOVE ..............*/
 if (Evnt->evnt & MU_MOVE)   /*  (EZGEM evenement)   */
    {Xform_mu_move(w_ind, Evnt);
    }       
    
 /*..........................Rpondre aux messages MU_MESAG ..............*/
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_EDIT_UPDATE:
             /**************************************************************/
             /*................ WM_EDIT_UPDATE (EZ_GEM message)............*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* un editeur de texte lui notifie un changement succeptible  */
             /* d'entrainer une mise a jour de la fenetre, ou lui notifie  */
             /* une action future pouvant etre modifiee.                   */
             /* en Evnt->pipe[X_G] se trouve la nature de la notification  */
             /* si egal a:                                                 */
            {TXTED_OB* TXT_A; 
             EVNT_O *Evnt_txt; 
             switch(Evnt->pipe[X_G])
               {/*..... ED_CLICK_IN (il a ete clique dans le texte)...............*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_CLICK_IN:
                    {(long)TXT_A       = *(long*)&Evnt->pipe[W_G]; 
                     (long)Evnt_txt    = *(long*)&Evnt->pipe[X_B];
                     /*.................. BOUTON DROIT ...........................*/
                     if (Evnt->k == 2)  
                        {char  item_str[MAX_PATH];
                         char  path[MAX_PATH];
                         int   ob_r;
                         void* adr_rsc   = GETWINDRSC(w_ind);
                         /*....... rechercher le path des ressources ........*/
                         /*    (l ou devrait se trouver: EDITPOP.POP        */
                         if (adr_rsc< (void*) 10) return 1;
                         GetPathRsc(adr_rsc, path);
                         
                         /*.......... appel du popup fichier .............*/
                         *item_str=0;
                         ob_r = DoPopMenuFromFile(object, EZ_INFO_ONG_CONTAINER, path, "EDITIND.POP", item_str);
                             
                         if (*item_str && ob_r>0)
                            {/*...... regarder si c'est pas un item ......*/
                             /*       de la liste des fenetres            */
                             /*........... extraire les mots en partant de la fin .........*/
                              
                             int key, ksp;
                             /* int ret; 
                             ret = */ StrMenuToShortCut(item_str, &key, &ksp);
                            }
                         Evnt->evnt     &= ~MU_BUTTON;
                         Evnt_txt->evnt &= ~MU_BUTTON;
                         Evnt->k         = 0;
                         Evnt_txt->k     = 0;
                         return 0;
                        }
                        
                     else  if ( !(TXT_A->State & MO_TRACK_ON) 
                             ) 
                        {long lig      = Evnt_txt->y;
                         long col      = Evnt_txt->x;
                         char *txt     = EZ_ED_GetLigCol(XY_TO_LIGPT, &lig, &col, TXT_A);
                         if (OngActif==EZ_INFO_ONG_INTDEP)
                            {if (Evnt_txt->click == 2)
                                ActiveDependList(TXT_A, Evnt_txt->x, Evnt_txt->y, GOTO_OPENWIND|SET_TO_TOP);
                             else
                                ActiveDependList(TXT_A, Evnt_txt->x, Evnt_txt->y, 0);
                            }
                         else
                            {if (Evnt_txt->click == 2)
                                ActiveMessList(PathIndex, TXT_A->ptTxt, txt, GOTO_OPENWIND|SET_TO_TOP);
                             else
                                ActiveMessList(PathIndex, TXT_A->ptTxt, txt, 0);
                            }
                        }
                    } break;
                /*.......  ED_KEYB_DWN (une touche CLAVIER a ete appuyee)..........*/
                /* en:    *(long*)&Evnt->pipe[W_G] adresse de l'editeur de texte  */
                /*        *(long*)&Evnt->pipe[X_B] variable de flux evenementiel  */ 
                /* Si il est retourne 0  ce message, l'editeur de texte ne       */
                /* ne recevra pas l'evenement.                                    */
                case ED_KEYB_DWN:
                case ED_KEYB_CNTRL:
                case ED_KEYB_ALT:
                    {char scan;
                     (long)TXT_A       = *(long*)&Evnt->pipe[W_G]; 
                     (long)Evnt_txt    = *(long*)&Evnt->pipe[X_B];
                      scan        = (char)(Evnt_txt->key>>8);
                      
                      /*....... n'autoriser que CNTRL C et CTRL A .............*/
                      if (Evnt->pipe[X_G] == ED_KEYB_CNTRL ||
                          Evnt->pipe[X_G] == ED_KEYB_ALT
                         )
                         {char car  = (char)ScanToAscii(Evnt_txt->key, Evnt_txt->ksp);
                          if (strchr("aAcC",car)) return 1;
                          else                    return 0;
                         }
                      /*....... n'autoriser que les touches flechees ..........*/
                      switch(scan)
                         {case 0x1C:      /* ENTER                      */
                          case 0x72:      /* RETURN    Activer la ligne */
                               {long lig  = Evnt_txt->y;
                                long col  = Evnt_txt->x;
                                char *txt = EZ_ED_GetLigCol(CURS_POSXY, &lig, &col, TXT_A);
                                
                                if (OngActif==EZ_INFO_ONG_INTDEP)
                                   {if (scan == 0x72)
                                       {ActiveDependList(TXT_A, (int)col, (int)lig, GOTO_OPENWIND|SET_TO_TOP);
                                        SendWindMessage(w_h, WM_TOPPED, &Windtab[w_ind].GemWorkGrect);
                                       }
                                    else
                                       {ActiveDependList(TXT_A, (int)col, (int)lig, 0);
                                       }
                                   }
                                else
                                   {txt = DebOfLine(TXT_A->ptTxt, txt);
                                    if (scan == 0x72)
                                       {ActiveMessList(PathIndex, TXT_A->ptTxt, txt, GOTO_OPENWIND|SET_TO_TOP);
                                        /*wind_set(GETGEMHAND(w_ind), WF_TOP);*/
                                        SendWindMessage(w_h, WM_TOPPED, &Windtab[w_ind].GemWorkGrect);
                                       }
                                    else
                                       {ActiveMessList(PathIndex, TXT_A->ptTxt, txt, 0);
                                       }
                                    }
                                }
                                return 0;
                          case 75:
                          case 72:
                          case 80:
                          case 77:
                          case 71:
                            return 1;
                          default:
                            return 0;
                         }/* end switch */
                        
                    } /* endcase ED_KEYB_ALT: */
               } /* endswitch(Evnt->pipe[X_G]) */
       } /* end case WM_EDIT_UPDATE: */
                     return 1;
        case WM_ONGLET_CHG:
            {/* TXTED_OB  TXT_FUNC;   stockera le composant d'edition des fonctions   */
             /* TXTED_OB  TXT_INDX;   stockera le composant d'edition des index       */
             /* TXTED_OB  TXT_MESS;   stockera le composant d'edition des messages    */
             /* TXTED_OB  TXT_INDP;   stockera le composant d'edition des dependances */
             TXTED_OB  *TXT_A = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
             long     len_src = TXT_A->EndTxt - TXT_A->ptTxt + 2;
             int wind_Parm    = IsWindExist(W_CONFIG);

             if (*(long*)&Evnt->pipe[W_G] != (long)object) return Evnt->evnt; 
             /*............. selon dialogue qui va etre desactive ...............*/
             /*              il faut sauver son texte                            */
             switch(OngActif)               
                {case EZ_INFO_ONG_INDEX:
                      if (TXT_INDX) free(TXT_INDX); TXT_INDX = 0;
                      if (len_src)
                         {TXT_INDX = malloc( len_src);
                          if (TXT_INDX) 
                             {memcpy(TXT_INDX, TXT_A->ptTxt, len_src);
                             }
                         }
                      break;
                 case EZ_INFO_ONG_LOGOUT:
                      if (TXT_MESS) free(TXT_MESS); TXT_MESS = 0;
                      if (len_src)
                         {TXT_MESS = malloc( len_src);
                          if (TXT_MESS) 
                             {memcpy(TXT_MESS, TXT_A->ptTxt, len_src);
                             }
                         }
                      break;
                 case EZ_INFO_ONG_INTDEP:
                      if (TXT_INDP) free(TXT_INDP); TXT_INDP = 0;
                      if (len_src)
                         {TXT_INDP = malloc( len_src);
                          if (TXT_INDP) 
                             {memcpy(TXT_INDP, TXT_A->ptTxt, len_src);
                             }
                         }
                      break;
                 case EZ_INFO_ONG_FONCT:
                      if (TXT_FUNC) free(TXT_FUNC); TXT_FUNC = 0; 
                      if (len_src)
                         {TXT_FUNC = malloc( len_src);
                          if (TXT_FUNC) 
                             {memcpy(TXT_FUNC, TXT_A->ptTxt, len_src);
                             }
                         }
                      break;
                }
             /*............. selon dialogue qui va etre active ..................*/
             /*              il faut replacer son texte en edition               */
             OngActif = Evnt->pipe[X_G];
             /*............. effacer le texte en edition ........................*/
             /*             (devrait deja avoir ete sauve)                       */
             TXT_A->State    |= (EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
             EraseAll(w_ind);
             switch(OngActif)               /* selon dialogue qui va etre active    */
                {case EZ_INFO_ONG_INDEX:
                      MemoryPut( w_ind,  TXT_INDX);
                      if (TXT_INDX) free(TXT_INDX); TXT_INDX = 0; 
                      WcontrolOngActif = 0;
                      break;
                 case EZ_INFO_ONG_LOGOUT:
                      MemoryPut( w_ind,  TXT_MESS);
                      if (TXT_MESS) free(TXT_MESS); TXT_MESS = 0;
                      WcontrolOngActif = 1;
                      break;
                 case EZ_INFO_ONG_INTDEP:
                      MemoryPut( w_ind,  TXT_INDP);
                      if (TXT_INDP) free(TXT_INDP); TXT_INDP = 0;
                      WcontrolOngActif = 2;
                      break;
                 case EZ_INFO_ONG_FONCT:
                      MemoryPut( w_ind,  TXT_FUNC);
                      if (TXT_FUNC) free(TXT_FUNC); TXT_FUNC = 0;
                      WcontrolOngActif = 3;
                      break;
                }
             if (wind_Parm != -1) ExeWindMessage(wind_Parm, WM_PRM_ONG_UPDATE, 0, 0);
             TXT_A->State    &= ~(EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
             /*Wobjc_draw(w_ind, object, EZ_INFO_BOX, 2, 0);*/
             SendObjectRedraw(GETGEMHAND(w_ind), object, EZ_INFO_BOX);
            }
             break;
        case WM_CONSTRUCT:
            {GRECT     new_grect, old_grect, scrgrect;
             int       i; 
             char *txt;
             long len;
             TXTED_OB  *TXT_A;
             int open_flag;
             /*......... charger et integrer la ressource ........*/
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "EZ_INFO.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;
             object = GETWINDTREE(w_ind);
             TXT_A           =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
             /*............. ouvrir eventuellement avec coordones ...........*/
             /*              du fichier de parametrage                        */
             new_grect = *(GRECT*)&Evnt->pipe[X_B];
             old_grect = new_grect;
             if (wControlDefGrect.g_x != -1 &&
                 wControlDefGrect.g_y != -1 &&
                 wControlDefGrect.g_w != -1 &&
                 wControlDefGrect.g_h != -1
                ) 
                {new_grect = wControlDefGrect;
                }
             
             /*....... placer chemin des includes dans la ressource ..........*/
             len    = ObjcGetLenTxt (object, EZ_INFO_INCL_PATH, &txt);
             StrPathStrNameToStrPath(txt, InclPath, 0, len-1);
             /*....... Ajuster le rectangle d'entree .........................*/
             /*        afin qu'il ne depasse pas l'ecran                      */
             wind_get(0,4,&scrgrect.g_x, &scrgrect.g_y, &scrgrect.g_w, &scrgrect.g_h);
             AdjustGrectToGrect(&scrgrect, &new_grect);
             new_grect.g_h = Min(scrgrect.g_h, new_grect.g_h);
             new_grect.g_w = Min(scrgrect.g_w, new_grect.g_w);
             AdjustXYGrectToScreen (new_grect.g_x + (new_grect.g_w>>1), new_grect.g_y + (new_grect.g_h>>1), &new_grect) ;
             AdjustInfRscToNewGrectWind(Windtab[w_ind].w_attr, object, &old_grect, &new_grect);
             *(GRECT*)&Evnt->pipe[X_B] = new_grect;
             /*........... preactiver le bon onglet ..............*/
        case WM_INIT_BOOK:
             open_flag                      = (int)Windtab[w_ind].UserPtr;
             if (open_flag == -1) open_flag = WcontrolOngActif;
             switch(open_flag)
               {case 0:  i = EZ_INFO_ONG_INDEX;  break;
                case 1:  i = EZ_INFO_ONG_LOGOUT; break;
                case 2:  i = EZ_INFO_ONG_INTDEP; break;
                case 3:  i = EZ_INFO_ONG_FONCT;  break;
                default: i = EZ_INFO_ONG_FONCT;  break;
               }
             /*....... initialiser la valeur que lors de la creation .......*/
             /*        car ensuite elle sera consideree comme               */
             /*        la valeur ancienne lors d'un changement d'onglet     */
             if (Evnt->pipe[MESG] == WM_CONSTRUCT) 
                {WcontrolOngActif = open_flag;
                 OngActif = i;
                }
             ActiveOnglet(w_ind, EZ_INFO_ONG_MASTER, i);
             /*........... ajuster taille ascensseur .......................*/
             AdjustSrollInfoSlide(object);
             TXT_A           =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
             TXT_A->State   |=  EDIT_MOFORM_ARROW;
             ATT_HEAD        =  TXT_A->ATT_Def[ATT_TXT_NUM_LGN];
             ATT_INCL        = ATT_HEAD;
             ATT_CLAS        = ATT_HEAD;
             ATT_WARN        = ATT_HEAD;
             ATT_FUNC        = ATT_HEAD;
             ATT_METH        = ATT_HEAD;
             ATT_ERRR        = ATT_HEAD;
             ATT_CLAS.CarCol = 13;   /* bleu turquoise */
             ATT_INCL.CarCol = 9;    /* Gris clair     */
             ATT_WARN.CarCol = 9;    /* Gris clair     */
             ATT_FUNC.CarCol = 4;    /* bleu clair     */
             ATT_METH.CarCol = 13;   /* bleu turquoise */
             ATT_ERRR.CarCol = 14;   /* jaune fonc    */
             /*ATT_METH.CarEff = 8;  */  /* souligne       */
             
             ATT_HEAD.CarEff = 8;    /* souligne       */
             
             EZ_ED_SetDrawLineFunc(AfficheInfoLigne,TXT_A);
             UpdateParamTexte( object, EZ_INFO_BOX, TXT_A);
             /*if (Evnt->pipe[MESG]== WM_INIT_BOOK)*/
            }
        case WM_ACT_TXT_CHG: /* reu chaque fois qu'une fenetre texte prend le focus */
            {int wind_targ               = IsWindExist(CurIDDoc);
             if (wind_targ>-1)
                {TXT_GFG   *ptTxtCfg     =  WTXT_CFG(wind_targ);
                 char path[MAX_PATH]; path[0] = 0;
                 if (ptTxtCfg)
                    {strcpy(path, ptTxtCfg->PathTxt);
                     strcat(path, ptTxtCfg->NomTxt);
                    }
                 ObjcSetTxt(object, EZ_INFO_INFO_TITLE, path);
                 if (Evnt->pipe[MESG] == WM_ACT_TXT_CHG)
                    {Wobjc_draw(w_ind, object, EZ_INFO_INFO_TITLE, 2, 0);
                    }
                }
             /* if (Evnt->pipe[MESG]== WM_INIT_BOOK) */
            }
             break;
             
        case WM_DESTRUCT:       /*  (EZGEM message)   */
            {int der_wind = GetDerTXT_Wind(w_ind);
             Xform_Destruct(w_ind, Evnt);    
             RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);
             /*....... liberer les memoire tampons ............*/
             if (TXT_INDX) free(TXT_INDX);
             if (TXT_MESS) free(TXT_MESS);
             if (TXT_INDP) free(TXT_INDP);
             if (TXT_FUNC) free(TXT_FUNC);
             TXT_INDX = TXT_MESS = TXT_INDP = TXT_FUNC = 0;
             /*...... si plus de fenetre Texte.................*/
             /*            on quitte EZ_EDIT                   */
              if (der_wind == -1) EZGemRun = -1;
             }
             break;
        case WM_MOUSEWHEEL:       Xform_WheelButton(w_ind, Evnt, 3);                  
             break;
        case WM_TT_ON_OFF:      /*  (EZGEM message)   */
             SetBulleState(Windtab[w_ind].w_h, Windtab[w_ind].DlgVar.tree);
             break;
        case WM_TT_GET_TXT:     /*  (EZGEM message)   */
             /**************************************************************/
             /*...................... WM_TT_GET_TXT .(EZGEM message).......*/
             /* Ce message est envoy a notre procedure de fenetre chaque  */
             /* fois que le systeme d'affichage d'une bulle d'aide desire  */
             /* qu'on lui fournisse un texte  afficher.                   */
             /* Ce texte peut etre affiche sur plusieurs lignes en mettant */
             /* comme separateur le signe | .                              */
             /* Exemple:                                                   */
             /* strcpy(sztt_txt,"Premiere ligne|deuxieme ligne|troisieme");*/
             /* Si vous placez une chaine vide "", la bulle d'aide ne sera */
             /* pas affichee.                                              */
             /*  Exemple: strcpy(sztt_txt,"");                             */
              
             {char *sztt_txt = (char*)     *(long*)(&Evnt->pipe[W_G]);
              char *pt_head  = 0;
              switch ( Evnt->pipe[Y_G]) 
                    {case EZ_INFO_UPDATE_INTDEP:
                     case EZ_INFO_UPDATE:
                          {int wind  = IsWindExist(CurIDDoc);
                           int ident = GETWINDIDENT(wind);
                           if (wind>-1 && IS_IDWINDTXT(ident) ) 
                              {TXT_GFG *ptWTxtCfg = WTXT_CFG(wind);
                               strcat(sztt_txt, ptWTxtCfg->NomTxt);
                              }
                          }
                          break;
                     
                     case EZ_INFO_DELETE_LIST_LOGOUT: pt_head = "LOADED"; break;
                     case EZ_INFO_DELETE_LIST_INTDEP: pt_head = "DEPEND"; break;
                     case EZ_INFO_DELETE_LIST:
                     case EZ_INFO_TRIER_LIST:         pt_head = "LISTED"; break;
                    }
              if (pt_head)
                 {TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
                  char path[MAX_PATH];
                  char nom[MAX_PATH>>1];
                  path[0]=0;
                  if (FIndPathOfCurentLineV2(TXT_A, EZ_ED_GETCURLIG(TXT_A), path, pt_head))
                     {PathNomToNomFic(path, nom);
                      strcat(sztt_txt, nom);
                     } 
                 }
             }
             break;  
        case WM_REDRAW: 
             Lister_rectangles(Windtab[w_ind].w_h,(GRECT*)&Evnt->pipe[X_G]);                          
             break;     
             
        case WM_BOTTOM:
             wind_set(Windtab[w_ind].w_h, WF_BOTTOM );
             break;
             
        case WM_TOPPED:
             wind_set(Windtab[w_ind].w_h, WF_TOP ); /* voila c'est fait !! */
             break;
             
        case WM_CLOSED: 
             DestroyWindow(Windtab[w_ind].w_h);
             break;
             
        case WM_ALLICONIFY:
             AllIconify((GRECT*)& Evnt->pipe[X_G]);
             break;
              
        case WM_ICONIFY:
             IconifyWindow(w_ind,(GRECT*)& Evnt->pipe[X_G]);
             break;
             
        case WM_UNICONIFY:
             UnconifyWindow(w_ind);
             break;
             
        case WM_SIZED:
             {GRECT wgrect, old_wgrect,deltgrect;
              int deltx,delty;
              CloseListBox (w_ind);

              GetGemWindExtGRECT(Windtab[w_ind].w_h, &wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr, &wgrect, &old_wgrect);
              WindGemBorderToEZWork(Windtab[w_ind].w_attr,(GRECT*)& Evnt->pipe[X_G], &wgrect);

              deltx = wgrect.g_w -  old_wgrect.g_w;
              delty = wgrect.g_h -  old_wgrect.g_h;
              object[EZ_INFO_VERT_BAR].ob_x           += deltx;
              object[EZ_INFO_VERT_UP].ob_x            += deltx;
              object[EZ_INFO_VERT_DOWN].ob_x          += deltx;
              object[EZ_INFO_BULLE_ON_OFF].ob_x       += deltx;
              object[EZ_INFO_BOX].ob_width            += deltx;
              object[EZ_INFO_VERT_DOWN].ob_y          += delty;
              object[EZ_INFO_VERT_BAR].ob_height      += delty;
              object[EZ_INFO_BOX].ob_height           += delty;
              
              object[EZ_INFO_HORZ_BAR].ob_y           += delty;
              object[EZ_INFO_HORZ_LEFT].ob_y          += delty;
              object[EZ_INFO_HORZ_RIGHT].ob_y         += delty;
              object[EZ_INFO_HORZ_RIGHT].ob_x         += deltx;
              object[EZ_INFO_HORZ_BAR].ob_width       += deltx;
              
              SetScrollBoxParam(object,EZ_INFO_BOX,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_NODRAW);
              OnWm_sized(w_ind, Evnt);
              SetScrollBoxParam(object,EZ_INFO_BOX,-2,-2,-2,-2,-2,-2,-2,-2,(void*)-2L,LST_DRAW);
              SendObjectRedraw(w_h, object, EZ_INFO_BOX);

              /*................ ajuster les ascenseurs ...........*/
              AdjustSrollInfoSlide(object);
              SendObjectRedraw(w_h, object, EZ_INFO_HORZ_BAR);
              SendObjectRedraw(w_h, object, EZ_INFO_VERT_BAR);
              /*................. TRACER LES RELIQUATS ............*/
              objc_offset(object,EZ_INFO_BOX,&deltx,&delty);
              if (wgrect.g_w<old_wgrect.g_w)
                 {deltgrect.g_x = deltx + object[EZ_INFO_BOX].ob_width;
                  deltgrect.g_y = wgrect.g_y;
                  deltgrect.g_w = wgrect.g_x + wgrect.g_w - deltgrect.g_x;
                  deltgrect.g_h = wgrect.g_h;
                  SendGrectRedrawMessage( Windtab[w_ind].w_h, &deltgrect);
                  ExeAllMessage();
                 }
                 
              if (wgrect.g_h<old_wgrect.g_h)
                 {deltgrect.g_x = wgrect.g_x;
                  deltgrect.g_y = delty + object[EZ_INFO_BOX].ob_height;
                  deltgrect.g_w = wgrect.g_w;
                  deltgrect.g_h = wgrect.g_y + wgrect.g_h - deltgrect.g_y;
                  SendGrectRedrawMessage( Windtab[w_ind].w_h, &deltgrect);
                  ExeAllMessage();
                 }
              /*........... mettre  jour le rectangle edition texte ........*/
              UpdateParamTexte( object, EZ_INFO_BOX, EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX));
              wControlDefGrect = Windtab[w_ind].ExtGrectUse;
             }break;
             
        case WM_MOVED:
             OnWm_moved(w_ind, Evnt);
             wControlDefGrect = Windtab[w_ind].ExtGrectUse;
             break;   
             
        case WM_FULLED: 
             OnWm_fulled( w_ind, Evnt);
             break;  
             
       } /* end switch message     */
    } /* end if Evnt & MU_MESSAG  */      
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*--------------------------- ActiveDependList -------------------------------*/
int ActiveDependList(TXTED_OB  *TXT_A, int x, int y, int flag)
{long lig      = y;
 long col      = x;
 char *txt     = EZ_ED_GetLigCol(XY_TO_LIGPT, &lig, &col, TXT_A);
 char *pt_deb  = txt;
 char *pt_end  = txt+col;
 char *path    = InclPath;    /* a priori rechercher dans path INCLUDE     */
 char inquote  = 0;
 char master_path[MAX_PATH];
 char nom[MAX_PATH];
 char arg_lig[32];
 
 /*............... si on est sur une entete ...............................*/
 if (pt_deb[0]=='' && pt_deb[1]=='')
    {while(*pt_deb !=' ')pt_deb++;
     pt_deb = GoFirstValid(pt_deb," ");
     Extrait_mot(master_path, pt_deb, 0," ");
     PathNomToNomFic(master_path, nom);
     if (LoadTxtInWind(master_path,  nom, 0, flag)) return 1;
     else                                           return 0;
    }
 /*.................. rechercher si on est pas dans .......................*/
 /*                   <fichier.h> ou "fichier.h"                           */
  while (*pt_end && *pt_end != '\r')
    {if ( *pt_end == '>' || *pt_end == '"') 
        {pt_deb = pt_end -1;
         while (pt_deb>txt)
           {if ( *pt_deb == '<' || *pt_deb == '"')
               {break;
               }
            pt_deb--;
           } /*endwhile (*pt_deb>txt) */
         break;
        } /*endif ( *pt_end == '>' || *pt_end == '"') */
     pt_end++;
    } /*endwhile (*pt_end && *pt_end |= '\r') */

/*................. si on est dans un fichier le charger ...................*/
/*                   <fichier.h> ou "fichier.h"                           */
if ( (*pt_deb=='<' ||*pt_deb=='"') && (*pt_end=='>' || *pt_end=='"') )
   {char sav;
    pt_deb++;          /* se placer apres le '<'    */
    sav = *pt_end; *pt_end=0;
    /*...... recuperer nom du fichier ..........*/
    strcpy(nom, pt_deb);
    *pt_end = sav;
    /*...... recuperer path maitre .............*/
    /*    celui du fichier dont on liste les    */
    /*    dependances                           */
    master_path[0] = 0;
    if (FIndPathOfCurentLineV2(TXT_A, txt ,master_path, "DEPEND"))
       {PathNomToNomFic(master_path, 0); /* eliminer nom d'origine         */
        if (FicLen(master_path,  nom) == -1L)  path = InclPath;
        else                                   path = master_path;
        if (FicLen(path,  nom) != -1L)
           {if (LoadTxtInWind(path, nom, 0, flag)) return 2;
            else                                   return 0;
           } /* end else de if  (FicLen(path,  nom) != -1L) */
       } /* endif (FIndPathOfCurentLineV2(TXT_ */
   } /* endif ( (*pt_deb=='<' ||*pt_deb=='"' */

/*................. chercher le chemin ou est inclus ce fichier .........*/
/*                   <fichier.h> ou "fichier.h"                          */
pt_deb  = txt;       /* on repart du debut de la ligne                   */
while (*pt_deb && *pt_deb != '\r')
      {if (*pt_deb=='"') inquote ++;
       if (*pt_deb=='>' || inquote>=2) break;
       pt_deb++;
      } 
if (*pt_deb=='>' || *pt_deb=='"')
   {char sav;
    char *pt = GoFirstValid(pt_deb+1," :");
    pt       = Extrait_mot(arg_lig, pt, 0," :");
    pt       = GoFirstValid(pt," :");
    pt_end   = EndOfLine(pt);
    sav      = *pt_end; *pt_end = 0;
    strcpy(master_path, pt);
    *pt_end  = sav;
    if (FicLen(master_path,  0) != -1L)
       {PathNomToNomFic(master_path, nom);
        if (LoadTxtInWind(master_path, nom, Max(0,atol(arg_lig)-OFSL), flag)) return 3;
        else                                                                  return 0;
       } /* end else de if  (FicLen(path,  nom) != -1L) */
   }
return 0;
}

/*---------------------- ListerAllDepList ----------------------------------*/
void ListerAllDepList(int w_h, OBJECT *object, int ident_in)
{int wind, ident;
 char *txt;
 /*.............. voir si include GCCShell dans environnement ..............*/
 
 /*............... fenetre seule ............................................*/
 if (ident_in)
    {ident = ident_in;
     wind  = IsWindExist(ident);
     if (wind !=-1 && IS_IDWINDTXT(ident) )
        {TXT_GFG *ptWTxtCfg = WTXT_CFG(wind);
         FlagInc = 0;
         
         if (TesteGCCShellInclude(ptWTxtCfg->NomTxt))
              {long len    = ObjcGetLenTxt (object, EZ_INFO_INCL_PATH, &txt);
               StrPathStrNameToStrPath(txt, InclPath, 0, len -1);
               SendObjectRedraw( w_h, object, EZ_INFO_INCL_PATH); 
              }
         
         AddFuncList(ptWTxtCfg->PathTxt, ptWTxtCfg->NomTxt, INDEX_ADDSTRING, "DEPEND", "  : Inclue les fichiers suivants ");
         MakeInterDepList(ptWTxtCfg->PathTxt,ptWTxtCfg->NomTxt);
        } /* endif(IS_IDWINDTXT(ident) ) */
    }
 /*............... toutes les fenetres .....................*/
 else
    {for (wind=0; wind<MAX_WIND; wind++)
      {ident = GETWINDIDENT(wind);
       if (IS_IDWINDTXT(ident) ) 
          {TXT_GFG *ptWTxtCfg = WTXT_CFG(wind);
           FlagInc  = 0;
           
           if (TesteGCCShellInclude(ptWTxtCfg->NomTxt))
              {long len    = ObjcGetLenTxt (object, EZ_INFO_INCL_PATH, &txt);
               StrPathStrNameToStrPath(txt, InclPath, 0, len -1);
               SendObjectRedraw( w_h, object, EZ_INFO_INCL_PATH); 
              } 
           
           AddFuncList(ptWTxtCfg->PathTxt, ptWTxtCfg->NomTxt, INDEX_ADDSTRING, "DEPEND", "  : Inclue les fichiers suivants ");
           MakeInterDepList(ptWTxtCfg->PathTxt, ptWTxtCfg->NomTxt);
          } /* endif(IS_IDWINDTXT(ident) ) */
      } /* end for(wind==0; wind<MAX_WIND; wind++) */
    } /*end else */
}

/*----------------------- TesteGCCShellInclude -------------------------------------*/
int TesteGCCShellInclude(char *nom)
{char ext[MAX_PATH];
 char *gcc_env  = 0;
 char *cpp_incl = 0;
 char *c_incl   = 0;
 char *pt       = 0;
 long len_ext;
 gcc_env  = getenv("GCCSHELL");
 if (gcc_env==0 || gcc_env[0] != '1')  return 0;
 if (GetExtension( nom, ext)==0)       return 0;
 strupr(ext+1);
 c_incl   = getenv("GNUINC");
 cpp_incl = getenv("GXXINC");
 len_ext  = strlen(ext);
 pt       = c_incl;
 while (*pt){if (*pt=='/') *pt='\\';
            pt++;
           }
 pt       = cpp_incl;
 while (*pt){if (*pt=='/') *pt='\\';
            pt++;
           }
 if (strncmp(ext,".C", len_ext)==0)
    {strcpy(InclPath, c_incl);
     return 1;
    }
 else if (strncmp(ext,".CC", len_ext)==0)
    {strcpy(InclPath, cpp_incl);
     return 1;
    }
 else if (strncmp(ext,".CPP", len_ext)==0)
    {strcpy(InclPath, cpp_incl);
     return 1;
    }
 return 0;
}
/*----------------------- MakeInterDepList ---------------------------------*/
int MakeInterDepList(char *path, char *nom)
{int w_ind_info = IsWindExist(W_EZ_INFO);
 int w_ind_txt  = IsThisTxtLoaded(path, nom);
 long len_txt   = 0;
 long       lig = 0;
 FILE *fh       = 0;
 long pt_data   = -1;   /* valeur initialisant fonction: GetNextData()  */
 long len_buf   = 0;
 int        i   = 0;
 int       flag = -1;
 int       Ncom = 0;
 int       Kw   = 0;
 char      is_der_buf;
 char buft[1024];
 char txt_scan[1024];
 char *pt_txt;
 char *pt_buf;
 char *pt_src;
 KEY_WRD    *key_out;
 OBJECT     *object;                                                          
 TXTED_OB   *TXT_L, *TXT_T;
 SYNT_PARAM *syntprm = SyntaxConfigure(nom);

 if (w_ind_info == -1) return 0;
 /*................ recuperer variables de texte ...................*/
 object  = GETWINDTREE(w_ind_info); 
 TXT_L   = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
 /*........... Si texte deja present alors on scanne la memoire ....*/
 /*               ou il se trouve                                   */
 if   (w_ind_txt != -1)
      {TXT_T   = EZ_ED_GetTxtEditStruct(GETWINDTREE(w_ind_txt), EZ_TXT_SCLBOX);
       EZ_ED_GraphUpdate(TXT_T) ;
       pt_buf  = TXT_T->ptTxt;
       len_buf = TXT_T->EndTxt - pt_buf;
      }
 /*........... Si texte non present on scanne le fichier ...........*/
 else
      {char path_l[MAX_PATH];
       len_txt = FicLen(path, nom);
       if (len_txt==-1)     return 0;
       strcpy(path_l, path);
       strcat(path_l, nom);
       fh      = fopen( path_l,"rb");
       pt_buf  = buft;
       len_buf = sizeof( buft)-1;
      }

 /*.......... initialiser le scan et lancer le scan ................*/
 pt_txt  = GetNextData(fh, pt_buf, &pt_data, &len_buf, &is_der_buf  );
 TXT_L->State    |= (EDIT_BLK_NOT_AFTER_PASTE|EDIT_SCRLH_NOT_AFTER_PASTE /*|EDIT_SCRLV_NOT_AFTER_PASTE*/);
 /*.......... Placer le Header .....................................*/
 
 while (pt_data != -1L)
       {if (i >= sizeof(txt_scan)-1) i = 0; /* faut pas depasser le buffer */
        txt_scan[i++] = *pt_txt;
        /*........ si fin de ligne atteinte on l'analyse ...........*/
        if (i>0 && txt_scan[i-1] == '\n') flag = i-1;
        if (i>1 && txt_scan[i-2] == '\r') flag = i-2;
        if (flag > -1)
           {txt_scan[flag]  = 0;
            pt_src          = txt_scan;
            /*...... tester si fin include special  EZ_GEM ........*/
            if (pt_src[0]=='/' && pt_src[1]=='*'  && pt_src[2]=='') break; /* EZ_SPECIAL end of include  */
            #pragma warn -pia   /* Possible incorrect assignment. */
            /*......... la sortie se fait pour chaque mot clef .....*/
            while ( (pt_src = IsKeyWordInThisLigne(txt_scan, pt_src, &Kw, &Ncom, &key_out, syntprm))!=0 )
              {pt_src += key_out->LenKey;
               if ( (strcmp( "include", key_out->Name))==0)
                  {AddIncludeInfo(w_ind_info, path, nom, lig, pt_src, FlagInc);
                  }
              }
            #pragma warn .pia
            i     = 0;
            flag  = -1;
            lig++;
           } /* endif (flag != 0)        */
        pt_txt      = GetNextData(fh, pt_buf, &pt_data, &len_buf, &is_der_buf );
        
       } /* endwhile (pt_data != -1L) */
 TXT_L->State    &= ~(EDIT_BLK_NOT_AFTER_PASTE|EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 if (fh) fclose(fh);
 return 1;
}

/*----------------------- AddIncludeInfo -------------------------------------*/
/* ACTION:                                                                    */
/* Normalement pt pointe apres le mot clef include                            */
long AddIncludeInfo(int w_ind_info, char *path, char *nom, long lig, char *pt, int flag)
{int param[8]; 
 OBJECT   *object   = GETWINDTREE(w_ind_info);                                                          
 TXTED_OB  *TXT_A   = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
 char  *pt_deb      = 0;
 char  *pt_end      = 0;
 long len_str       = 0;
 long is_exist      = -1;
 int pos            = (flag+1)*2;
 char buft[MAX_PATH];
 char master_path[MAX_PATH];
 char nom2[MAX_PATH>>1];
 char sav;
 
 
 
 /*....... preparer le debut de la chaine (version nom).............*/
 /*        NOMFIC.FIC: NUMLIGNE:                                    */
 
 strcpy(buft," | | | | | | | | | | | | | | | | | | | | | | | | | | | |");
 buft[pos] = 0;
 strcat(buft, "-");
 /*............. rechercher le fichier  inclure ...................*/
 /*       le nom forme dans buft est du type <nom.h> ou "nom.h"     */
 /*       CAD preleve comme trouve dans le texte avec les           */
 /*       crochets et les guillemets pour indiquer si l'include     */
 /*       appartient au dossier INCLUDE ou est dans le path         */
 /*       courant du projet.                                        */
 pt_deb = FindFirstSignifiant(pt);            /* chercher " ou <    */
 if (pt_deb==0)       return 0L;              /* pas trouve !!!     */
 pt     = pt_deb+1; /* se mettre apres le " ou > */
 while(*pt && *pt !='"' && *pt != '>') pt++;  /* chercher " ou >    */
 if (*pt==0)          return 0L;              /* pas trouve !!!     */
 pt_end = pt+1;     /* se mettre apres le " ou > */
 sav    = *pt_end; *pt_end = 0;
 strcat (buft+len_str, pt_deb);
 
 /*........... si cet include est deja liste .......................*/
 /*            placer symbole '' avant son nom                     */
 master_path[0]=0;
 if (FIndPathOfCurentLineV2(TXT_A, TXT_A->EndTxt  ,master_path, "DEPEND"))
    {is_exist = IfThisIncludeExist(TXT_A, master_path, 0, pt_deb);
    }
 *pt_end  = sav;
 strcat(buft,"     ");
 StrNcat(buft+len_str, ltoa(lig+OFSL,"               ",10),6);
 strcat(buft," ");
 strcat(buft, path);
 strcat(buft, nom);
 strcat(buft,"\r\n");
 
 if (is_exist != -1L)  buft[pos] = '';
 /*............ rechercher le fichier dans ce qui est deja liste ...........*/
 /*       le nom forme dans buft est du type  nom.h ou nom.h                */
 pt_end--;         /* se mettre avant le " ou >  */
 sav     = *pt_end; *pt_end = 0;
 strcpy(nom2, pt_deb+1);
 *pt_end = sav;

 /*........... copier le texte .............................................*/
 TXT_A->State    |= (EDIT_BLK_NOT_AFTER_PASTE);
 *(long*) &param[2]   = (long)TXT_A;
 /* *(long*) &param[0]   = (long)(TXT_A->EndTxt);                                */
 /* EZ_ED_DirectExeEditMessage(w_ind_info, EXE_ED_SET_CURS_POS, param, 4, TXT_A);*/
 *(long*) &param[0]   = (long)(buft);
 EZ_ED_DirectExeEditMessage(w_ind_info, EXE_ED_MEMORY_PASTE, param, 4, TXT_A);
 /*EZ_ED_DirectExeEditMessage(w_ind_info, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);*/
 TXT_A->State    &= ~(EDIT_BLK_NOT_AFTER_PASTE);
 /*............ si cet include n'existe pas deja ...........................*/
 if (is_exist==-1L)
    {/*........ si pas trouv dans path d'entete: DEPEND ...............*/
     /*         essayer avec celui du path d'include                        */
     if (FicLen(path,  nom2) == -1L)  path = InclPath;
     FlagInc++;
     MakeInterDepList(path, nom2);
     FlagInc--;
    }
 return (long)(pt_end - pt_deb);
}

/*---------------------- IfThisIncludeExist ----------------------------------*/
long IfThisIncludeExist(TXTED_OB  *TXT_A, char *path, char *nom, char *pt_deb)
{long len_str = strlen(pt_deb)-2; /* -2 car on compare sans les <> ou "" */
 char pt_path[MAX_PATH];
 char *deb, *end;
 long lig, l;
 char *txt;
 /*................ former le chemin complet .....................*/
 
 strcpy(pt_path, path);
 if (nom) strcat(pt_path, nom);
 /*................. rechercher dans la liste le bloc de .........*/
 /*                            donnees du path                    */
 lig = IsThisFuncListInWind(TXT_A, pt_path, 0, &deb, &end,  "DEPEND");
 if (lig == -1)           return -1;
 /*............. analyser chaque ligne du bloc ...................*/ 

 for (l = lig; l<TXT_A->NbLgn; l++)
     {txt = EZ_ED_GETTXT(TXT_A, l, 0);
      /*........ rechercher le debut du nom de fichier .........*/
       while(*txt && *txt != '\r')
            {if ( (*txt == '<' || *txt == '"')       &&
                   strncmp(txt+1, pt_deb+1,len_str)==0
                )       return l;
             txt++;
            } /* endwhile(*txt && *txt != '\r' && *txt != '') */
      } /*endfor (l = lig; l<TXT_A->NbLgn; l++)  */
 return -1;
}

/*----------------------- FindFirstSignifiant --------------------------------*/
/* ACTION:  scanne tout le texte pointe par pt, saute les commentaires les    */
/*          espaces, les \r \n et s'arrete au premier caractere trouve        */
/* ENTREE: char * pt: texte dont il faut trouver le premier caractere         */
/*                    signifiant.                                             */
/* RETOUR: char *: pointeur sur le premier caractere signifiant.              */
/*                 si zero c'est que pas trouve (on est dans un commentaire   */
/*                         ou que des espaces et \r\n apres le pt de debut)   */
char *FindFirstSignifiant(char *pt)
{int ncom =0;
 while(*pt)
  {if (ncom==0 && pt[0]=='/' && pt[1]=='*') 
      {ncom = 1;
       pt  += 2;
      }
   else if (ncom && pt[0]=='*' && pt[1]=='/')
     {ncom = 1;
      pt  += 2;
     }
   else if (ncom==0 && (pt[0] == ' ' || pt[0] == '\n' || pt[0] == '\r' || pt[0] == '\t') )
     {pt++;
     }
   else if (ncom==0) return pt;
   else pt++;
  }
 return 0;
}

/*----------------------- BeforeIsOk -----------------------------------------*/
int BeforeIsOk(char *buft, char *pt_src)
{if (buft == pt_src)      return 1;  /* si debut buffer mot clef est possible */
 if (IS_C_NAME(--pt_src)) return 0;  /* si avant c'est un car de mot clef     */
 return 1;
}


/*----------------------- IsKeyWordInThisLigne -----------------------------*/
/* ACTION: recherche si dans la ligne il y a un mot clef et si oui retourne */
/*         la classe graphique de ce mot clef dans: KEY_WRD **key_out       */
/* ENTREE: char *buft: pointe sur le buffer texte  analyser.               */
/*         char *pt_src: pointe sur l'endroit du buffer texte ou doit       */
/*                       commencer l'analyse.                               */
/*         int *pt_Ncom: etat (commentaire ou pas) de l'endroit ou doit     */
/*                       commencer l'analyse.                               */
/* RETOUR: char *: pointe sur le mot clef trouv.                           */

char *IsKeyWordInThisLigne(char *buft, char *pt_src, int *isInkwSection, int *isInSection, KEY_WRD **key_out, SYNT_PARAM  *syntprm)
{int   nb_car;
 int   dumy;
 char *beg_tab;
 char *end_tab;
 char *kwbeg_tab;
 char *kwend_tab;
 char *validTab;
 KWSECTION  *kwsection = 0;
#pragma warn -pia   /* Possible incorrect assignment. */
if (syntprm==0)                                       return 0;
kwsection     = &syntprm->KwSection[*isInkwSection];
validTab      = kwsection->ValidChar;
beg_tab       = kwsection->BegSection;
end_tab       = kwsection->EndSection;
kwbeg_tab     = syntprm->KwSectBegFirstCar;
kwend_tab     = syntprm->KwSectEndFirstCar;
while (*pt_src )
  {if (*isInSection )
      {if ( end_tab[*pt_src] &&
           (nb_car = IsEndSection(pt_src, isInSection, *isInkwSection, syntprm))
          )
          {pt_src        += nb_car;
          }
       else
          {pt_src++;
          }
      }
   else
      {if (validTab[*pt_src]                && /* si IS_C_NAME(pt_src)  len = au minimum 1 */
           BeforeIsOk(buft, pt_src)
          ) 
          {KEY_WRD key_input;
           nb_car           = CPY_KW_TO_TEST(pt_src, key_input.Name);
           key_input.LenKey = nb_car;
           *key_out         = (KEY_WRD*)bsearch(&key_input, 
                                                kwsection->KwAdr,
                                                kwsection->NbKeyW,
                                                sizeof(KEY_WRD),
                                                NewKeyWordCompare
                                              );
           /*........... sortir si mot clef trouv .................*/
           if (*key_out)                            
              {if (kwsection->MajMin & 4) *isInkwSection = 0;
               return pt_src;
              }
           pt_src   += nb_car;
          }
       else if ( beg_tab[*pt_src] &&
                (nb_car = IsBegSection(pt_src, isInSection, &dumy, *isInkwSection, syntprm))
               )
          {pt_src        += nb_car;
          }
       else if (*isInkwSection == 0   &&
                kwbeg_tab[*pt_src]    &&
                (nb_car = IsBegKwSection(pt_src, isInkwSection, &dumy, syntprm))
               )
          {kwsection          = &syntprm->KwSection[*isInkwSection];
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
           pt_src            += nb_car;
          }
       else if (*isInkwSection      &&
                kwend_tab[*pt_src]  &&
                (nb_car = IsEndKwSection(pt_src, isInkwSection, &dumy, syntprm))
               )
          {kwsection          = &syntprm->KwSection[*isInkwSection];
           validTab           = kwsection->ValidChar;
           beg_tab            = kwsection->BegSection;
           end_tab            = kwsection->EndSection;
           pt_src            += nb_car;
          }
       else
          {pt_src++;
          }
      }
   }  /* end while (*pt_src ) */
 /*........ traiter le cas du fin de section EOF .................*/
 /*         qui ne passe pas dans les test car while( EOF)        */
 if (*isInSection   && kwsection->SectionAdr[*isInSection-1].EndStr[0] == '\r')
    {*isInSection   = 0;
    }
 if (*isInkwSection && syntprm->KwSection[*isInkwSection].EndStr[0]  == '\r')
    {*isInkwSection = 0;
    }
 return 0;
#pragma warn .pia
}
/*----------------------- GetNextData --------------------------------------*/
/* ENTREE: char *buft: tampon ou doit etre stock le texte.                 */
/*                     soit de la longueur totale du texte et il contient   */
/*                     le texte, soit d'une longueur limitee et il contient */
/*                     partie seulement du texte, et alors si on arrive en  */
/*                     fin de tampon et que le handle de fichier est valide */
/*                     le tampon est automatiquement recharge avec la suite */
/*                     du fichier.                                          */


char *GetNextData(FILE *fh, char *buft, long *pt_data, long *len_buft, char *is_der_buff)
{/*............... initialiser sur 0 le buffer interne .....................*/
 long len;
 if (*pt_data == -1L) 
    {*pt_data           = 0;
     *is_der_buff       = 0;
     if (fh)
        {len = fread( buft, 1, *len_buft, fh );
         /*...... si les donnees chargees sont plus courtes ........*/
         /*       que le buffer, raccourcir le buffer au donnees    */
         /*       et mettre flag de dernier buffer  1              */
         if (len < *len_buft)
            {*len_buft    = len;
             *is_der_buff = 1;
            }
        }
     return buft;
    }
 /*............>>>>> SI la donne pointee est la fin du buffer .............*/
 if (*pt_data >= *len_buft - 1)
    {/*.......... >>> Si on est en lecture Scanning de fichier .............*/
     /*               (le handle de fichier est valide)                     */
     if (fh)
        {/*.......... si flag dernier buffer mis et qu'on est ..............*/
         /*          en fin de buffer alors ya plus rien apres              */
         /*                  ou est en fin de fichier                       */
         if (*is_der_buff)
            {*pt_data = -1;
             return buft + *pt_data;
            }
         len = fread( buft, 1, *len_buft, fh );
         /*...... si les donnees chargees sont plus courtes ................*/
         /*       que le buffer, raccourcir le buffer au donnees            */
         /*       et mettre flag de dernier buffer  1                      */
         if (len < *len_buft)
            {*len_buft    = len;
             *is_der_buff = 1;
            }
         *pt_data = 0;
        }
     /*.......... >>> Si on est en lecture Scanning d'un buffer ............*/
     /*               (le handle de fichier est invalide)                   */
     
     else  
        {*pt_data=-1;
        }
     return (buft);
    }
 /*........... >>>>> SI on est pas en fin de buffer avancer d'un octet .....*/
 else
    {*pt_data += 1;
     return (buft + *pt_data);
    }
}
/*----------------------- AddIndex -----------------------------------------*/
int AddIndex(char *path, char *nom, int flag)
{int w_ind =  IsWindExist(W_EZ_INFO);
 int mode;
 long param[8]; 
 char path_l[MAX_PATH];
 OBJECT    *object;
 TXTED_OB  *TXT_A; 
 flag++;
 if (w_ind == -1) return 0;
 /*................ recuperer variables de texte ...................*/
 object  = GETWINDTREE(w_ind);
 TXT_A   = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
 /*............. si le fichier est vide,  effacer les ..............*/
 /*              donnes le concernant de la liste                  */
 if (Fic_exist(path, nom)>0) mode = INDEX_ADDSTRING;
 else                        mode = 0;
 AddFuncList(path, nom, mode,
                 "LOADED", "  : Fichier d'index charge par EZ_EDIT "
            );
 /*............. si le fichier vide cassos .........................*/
 if (mode)
    {strcpy(path_l, path);
     if (nom) strcat(path_l, nom);
     /*............... placer le curseur texte en fin de  fichier ......*/
     param[0] = (long)(TXT_A->EndTxt);   /* curseur texte en fin de fichier       */
     param[1] = (long) TXT_A;            /*  W_G H_G  adresse de l'editeur cible   */
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
     /*............... merger le fichier ...............................*/
     param[0] = (long)(path_l);    /*  path du fichier a merger                  */
     param[1] = (long)TXT_A;       /*  W_G H_G  adresse de l'editeur cible       */
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_FILE_PASTE, (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,  (int*)param, 4, TXT_A);
     
    }
 return 1;
}
/*------------------------ MemoryPut ---------------------------------------*/
void MemoryPut(int w_ind, char *ptStr)
{int param[8]; 
 OBJECT   *object   = GETWINDTREE(w_ind);                                                          
 TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
 EZ_ED_GraphUpdate(TXT_A);
 if (ptStr==0) return;
 /*........... copier le texte .............................................*/
 *(long*) &param[2]   = (long)TXT_A;
 *(long*) &param[0]   = (long)(ptStr);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_MEMORY_PASTE,    param, 4, TXT_A);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,       param, 4, TXT_A);
 /*
 *(long*) &param[0]   = (long)TXT_A->ptTxt;
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS,    param, 4, TXT_A);
 */
}


/*------------------------ EraseAll ------------------------------------------------*/
void EraseAll(int w_ind)
{/*.................. version effaant tout ................................*/
 int param[8]; 
 OBJECT   *object   = GETWINDTREE(w_ind);
 TXTED_OB  *TXT_A   =  EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);   
 EZ_ED_GraphUpdate( TXT_A);                                        
 /*........... effacer le bloc .........................................*/
 *(long*) &param[2] = (long)TXT_A;                                       
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    param, 4, TXT_A);
 *(long*) &param[0] = (long)TXT_A->ptTxt;
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,  param, 4, TXT_A);
 *(long*) &param[0] = (long)TXT_A->EndTxt;
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,  param, 4, TXT_A);
 EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_DEL,          param, 4, TXT_A);
}
/*------------------------ TrierFonctions ------------------------------------------*/
int TrierFonctions(TXTED_OB  *TXT_A, char *path_in)
{char path[MAX_PATH];
 char *deb, *end, *pt_path;
 size_t  nbr_line_to_sort;
 size_t  len_line_to_sort;
 
 path[0] = 0;
 if      (path_in && *path_in)                                                       
          pt_path = path_in;
 else if (FIndPathOfCurentLineV2(TXT_A, EZ_ED_GETCURLIG(TXT_A), path,"LISTED"))  
          pt_path = path;
 else return 0;
 
 if (IsThisFuncListInWind(TXT_A, pt_path, 0, &deb, &end,"LISTED") >- 1
    )
    {deb               = NextLine(deb+2); /* se mettre en debut premiere ligne apres les "\r\n LISTED --- pas de ... " */
     len_line_to_sort  = NextLine(deb) - deb;
     nbr_line_to_sort  = (end - deb) / len_line_to_sort;
     qsort(deb, nbr_line_to_sort, len_line_to_sort, LineFuncCompare);
     return 1;
    }
 return 0;
}

/*-------------------------------- LineFuncCompare ------------------------*/
int LineFuncCompare (const void *one, const void *two)
{char         *deb1 = (char*) one;
 char         *deb2 = (char*) two;
 size_t byte_to_cmp = 0;
 char   *pt_par1,  *pt_par2;
 char   *pt_fnc1,  *pt_fnc2;
 char   *end_fnc1, *end_fnc2;

 pt_par1     = deb1;    
 while(*pt_par1)
      {if (*pt_par1 == '(' || *pt_par1 == 13 || *pt_par1 == 10) break;
       pt_par1++;
      }
 pt_par2     = deb2;
 while(*pt_par2)
      {if (*pt_par2 == '(' || *pt_par2 == 13 || *pt_par2 == 10) break;
       pt_par2++;
      }
 pt_fnc1     = FindDebFunc(deb1, pt_par1, &end_fnc1);
 pt_fnc2     = FindDebFunc(deb2, pt_par2, &end_fnc2);
 byte_to_cmp = Min(pt_par1-pt_fnc1, pt_par2-pt_fnc2);

 return strncmp(pt_fnc1, pt_fnc2, byte_to_cmp);

}
/*------------------------ ListerFonctions -----------------------------------------*/
void ListerFonctions(int ident_in)
{int wind, ident;
 long len_max = 0;
 /*............. relever la longueur max des chemins .......*/
 for (wind=0; wind<MAX_WIND; wind++)
   {ident = GETWINDIDENT(wind);
    if (IS_IDWINDTXT(ident) ) 
       {TXT_GFG *ptWTxtCfg = WTXT_CFG(wind);
        long len           = /*strlen(ptWTxtCfg->PathTxt) +*/ strlen(ptWTxtCfg->NomTxt);
        len_max            = Max( len, len_max);
       }
   } /* end for (wind=0; wind<MAX_WIND; wind++) */
 /*............ lister les fonctions .......................*/
 len_max = Min(len_max, 64);
 /*............... fenetre seule ...........................*/
 if (ident_in)
    {ident = ident_in;
     wind  = IsWindExist(ident);
     if (wind !=-1 && IS_IDWINDTXT(ident) )
        {TXTED_OB  *TXT_AL  = WTXT_A(wind);
         TXT_GFG *ptWTxtCfg = WTXT_CFG(wind);
         if (IsFindAnim==0)  TXT_AL->State |= EDIT_HIDE;
         if (AddFuncList(ptWTxtCfg->PathTxt, 
                         ptWTxtCfg->NomTxt, 
                         INDEX_ADDSTRING,
                         "LISTED","  : Liste des fonctions by EZ_EDIT "
                        )==0) return;
         FindAllFuncInWind(wind, (int)len_max, ident);
         if (IsFindAnim==0)  
            {TXT_AL->State &= ~EDIT_HIDE;  
             Wobjc_draw(wind, GETWINDTREE(wind), EZ_INFO_BOX, 1, 0);
            }
        } /* endif(IS_IDWINDTXT(ident) ) */
    }
 /*............... toutes les fenetres .....................*/
 else
    {for (wind=0; wind<MAX_WIND; wind++)
      {ident = GETWINDIDENT(wind);
       if (IS_IDWINDTXT(ident) ) 
          {TXTED_OB  *TXT_AL  = WTXT_A(wind);
           TXT_GFG *ptWTxtCfg = WTXT_CFG(wind);
           if (IsFindAnim==0)  TXT_AL->State |= EDIT_HIDE;
           if (AddFuncList(ptWTxtCfg->PathTxt, 
                           ptWTxtCfg->NomTxt, 
                           INDEX_ADDSTRING,
                           "LISTED","  : Liste des fonctions by EZ_EDIT ")
                           )
              {FindAllFuncInWind(wind, (int)len_max, ident);
               if (IsFindAnim==0)  
                  {TXT_AL->State &= ~EDIT_HIDE;  
                   Wobjc_draw(wind, GETWINDTREE(wind), EZ_INFO_BOX, 1, 0);
                  }
              } /* endif (AddFuncList(ptWTxtCfg->PathTxt, ptWTxtCfg->NomTxt, INDEX_ADDSTRING)) */
          } /* endif(IS_IDWINDTXT(ident) ) */
      } /* end for(wind==0; wind<MAX_WIND; wind++) */
    } /*end else */
}
/*-------------------- FindAllFuncInWind -------------------------------------------*/
long FindAllFuncInWind(int wind_src, int len_max, int ident)
{int     wind_lst   = IsWindExist(W_EZ_INFO);
 TXTED_OB   *TXT_A  = 0;
 TXT_GFG *ptTxtCfg  = 0;
 ERR_C err          = {0,0};
 char *ptfunc       = 0;
 char *pt           = 0;
 int    au_suivant  = TRUE;
 long occur         = 0;
 char buft[1024];
 long param[4];
 long lig, col;
 long len_prefix;
  
 /*............... si pas de fenetre controle ouverte sortir .......*/
 if (wind_lst == -1)            return 0;
 /*............... recuperer varibles de fenetre ...................*/
 if (wind_src>-1 && IS_IDWINDTXT(ident))
    {TXT_A    = WTXT_A(wind_src);
     ptTxtCfg = WTXT_CFG(wind_src);
    }
 if (TXT_A==0 || ptTxtCfg == 0) return 0;
 /*....... preparer le debut de la chaine (version nom).............*/
 /* strcpy(buft,ptTxtCfg->NomTxt); */
 /* strcat(buft,": ");             */
 strcpy(buft,": ");
 len_prefix = strlen(buft);
 
{/*.............. recuperer les variables d'edition ................*/
 /*               des saisies chercher, remplace, index             */
 TXTED_OB  *TXT_L = EZ_ED_GetTxtEditStruct(GETWINDTREE(wind_lst), EZ_INFO_BOX);
 /*........... initialiser boucle de recherche ......................*/
 pt               =  TXT_A->ptTxt;
 TXT_L->State    &= ~(EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 TXT_L->State    |=  (EDIT_SCRLH_NOT_AFTER_PASTE);
 if (IsIndexAnim == 0)  TXT_L->State |= (EDIT_HIDE|EDIT_SCRLV_NOT_AFTER_PASTE);
 if (IsFindAnim  == 0)  TXT_A->State |= (EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 /*............ mettre  jour le texte ..............................*/
 EZ_ED_GraphUpdate( TXT_A);
 EZ_ED_GraphUpdate( TXT_L);
 /*....... afficher LISTED E:\PURE_C\toolbox.c  : fichier .......*/
 /*........... boucle de recherche ..................................*/
 while (au_suivant)
    {if (IsIndexAnim)  EZ_ED_GraphUpdate(TXT_L);
     /*......si recherche de fonctions les rechercher ...............*/
     ptfunc = FindFunc(TXT_A->ptTxt, pt, &pt, &err);
     /*......Si erreur afficher le message d'erreur et cassos .......*/
     if (err.Flag) 
        {EZ_ED_GetLigCol((size_t) err.pt, &lig, &col, TXT_A);
         MakeMessageString(buft,
                           "Error", 
                           ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, len_max, 
                           lig, col, GetMessageError(err.Flag));
         AddString(wind_lst, buft, TXT_L);
         ptfunc = 0;
        }
     if (ptfunc==0) break;
     /*...... Mettre la fonction en video inverse dans le ...........*/
     /*       fichier source (que si animation)                      */
     if (IsFindAnim)  
        {EZ_ED_GraphUpdate(TXT_A); 
         param[0] = (long)(ptfunc);
         param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
         EZ_ED_DirectExeEditMessage(wind_src, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
         EZ_ED_DirectExeEditMessage(wind_src, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
         EZ_ED_DirectExeEditMessage(wind_src, EXE_ED_SET_SEL_DEB,  (int*)param, 4, TXT_A);
         param[0] = (long)(EndOfLine(ptfunc));
         EZ_ED_DirectExeEditMessage(wind_src, EXE_ED_SET_SEL_END,  (int*)param, 4, TXT_A);
        }
     occur++;
     /*............. ajouter l'occurence  l'index ..................*/
    {char sav;
     char *f = ptfunc;
     /*..... chercher ligne et colonne pointe.......................*/
     /*      pour afficher N ligne de la fonction                   */
     EZ_ED_GetLigCol((size_t) ptfunc, &lig, &col, TXT_A);
     buft[len_prefix] = 0;   /* fin de chaine = fin du prefix        */
     StrNcat(buft+len_prefix, ltoa(lig+OFSL,"               ",10),5);
     strcat (buft+len_prefix, ": ");
     /*......... rechercher fin de la ligne de la fonction ..........*/
     /*          et merger le texte de cette ligne                   */
     while(*f && *f != 13 && *f != 10) f++;
     sav = *f;
     *f  = 0;
     StrNcat(buft, ptfunc, LenFindStr); 
     *f  = sav;
     AddString(wind_lst, buft, TXT_L);  
    }
     /*........... tester interruption boucle ............*/
     if (!Kbshift(-1))  au_suivant = TRUE;
     else               au_suivant = FALSE;
    } /* endwhile  */
 if (occur==0) 
    {buft[len_prefix] = 0;   /* fin de chaine = fin du prefix        */
     StrNcat(buft+len_prefix, "-----: Pas de fonction trouve dans ce fichier !!! ",LenFindStr+9);
     AddString(wind_lst, buft, TXT_L);  
    }
 TXT_A->State &= ~(EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 /*........ si pas d'animation redessiner fenetre index a la fin .........*/
 TXT_L->State &= ~(EDIT_HIDE|EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 if (IsIndexAnim==0)
    { Wobjc_draw(wind_lst, GETWINDTREE(wind_lst), EZ_INFO_BOX, 1, 0); 
    }   
}
 return occur;
}
/*----------------------- AddFuncList ---------------------------------*/
/* ACTION: verifie si le fichier: char *path, char *nom                */
/*         n'est pas deja liste, si oui detruit la liste et rajoute    */
/*         si flag entree positionne sur INDEX_ADDSTING la chaine:     */
/*              LISTED E:\PATH\NOM.C : Liste des foncti../r/n      */
/* ENTREE:  char *path, char *nom: chemin soit complte dans path et    */
/*          nom doit etre egal  zero, soit separes.                   */
/* RETOUR: int 1/tout est OK  0/erreur.                                */

int AddFuncList(char *path, char *nom, int flag, char *head, char *mess)
{long param[4];
 OBJECT    *object ;
 TXTED_OB   *TXT_A ;
 char *deb, *end, *pt_path;
 char buft[1024];
 int w_ind =  IsWindExist(W_EZ_INFO);
 /*............. relever pointeur du path ..........................*/
 /*          construire "\r\nLISTED "                           */
 strcpy(buft, "\r\n");   /* "\r\n"                                  */
 strcat(buft, head);     /* "\r\nLISTED"                        */
 strcat(buft," ");       /* "\r\nLISTED "                       */
 
 pt_path = buft + strlen(buft); 
 /*.............. si c'est pas la fenetre bookmark cassos ..........*/
  
 if (w_ind == -1) return 0;
 /*................ recuperer variables de texte ...................*/
 object  = GETWINDTREE(w_ind); 
 TXT_A   = EZ_ED_GetTxtEditStruct(object, EZ_INFO_BOX);
 EZ_ED_GraphUpdate(TXT_A);
 /*................ si effacement de toute la fenetre ..............*/
 if (flag & INDEX_DELETE)
    {param[0] = (long)TXT_A->ptTxt;  
     param[1] = (long)TXT_A;       
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS,    (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,       (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,     (int*)param, 4, TXT_A);
     param[0] = (long)TXT_A->EndTxt;    
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,     (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_DEL,             (int*)param, 4, TXT_A);
    }
 strcpy(pt_path, path); 
 if (nom) strcat(pt_path, nom);   
 /*............... verifier si le fichier n'est pas ................*/
 /*                deja list  et alors effacer                     */
 /*                que la liste de ce fichier                       */
 TXT_A->State |= (EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE|EDIT_BLK_NOT_AFTER_PASTE);
 if (!(flag & INDEX_NOT_DEL) && IsThisFuncListInWind(TXT_A, pt_path, 0, &deb, &end,  head)>-1)
    {
     param[1] = (long)TXT_A;
     param[0] = (long)deb;
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS,    (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,       (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,     (int*)param, 4, TXT_A);
     param[0] = (long)end;    
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,     (int*)param, 4, TXT_A);
     EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_DEL,             (int*)param, 4, TXT_A);
    
    }
 /*.............. ajouter l'eventuelle entete de liste .............*/
 if (flag & INDEX_ADDSTRING)
    {/* strcat(buft,"  : Liste des fonctions by EZ_EDIT "); */
     strcat(buft, mess);     
     AddString(w_ind, buft, TXT_A);
    }
 TXT_A->State &= ~(EDIT_SCRLH_NOT_AFTER_PASTE|EDIT_SCRLV_NOT_AFTER_PASTE);
 return 1;
}

/*----------------------- IsThisFuncListInWind ------------------------*/
/* ACTION: recherche dans le texte d'une liste representee par le      */
/*         composant d'edition de texte: TXTED_OB   *TXT_A,            */
/*         une ligne commenant par le header pointe par la chaine:    */
/*         char* head: du type "LISTED" ou "XXXXXX"            */
/*         si trouve recherche si le chemin place apres cette chaine  */
/*         est egal  celui d'entree char *path: si egal alors il est  */
/*         retourne en char **deb et char **end, le bloc de donnes    */
/*         correspondant dans la liste (afin de l'effacer ou autres    */
/*         explorations)                                               */
/* ENTREE: TXTED_OB   *TXT_A: pointe sur le composant d'edition de     */
/*                            texte contenant la liste  explorer.     */
/*         char *path: pointe sur le chemin complet (avec le nom de    */
/*                     fichier) dont on recherche le bloc de donnes.  */
/*         long lig: ligne  partir de laquelle doit se faire la       */
/*                   recherche.                                        */
/*         char **deb, char **end: pointeur sur les pointeur de debut  */
/*                             et fin de bloc qui seront initialises   */
/*                             sur les valeurs de debut et fin de bloc */
/*                             si la recherche aboutit.                */
/*         char *head: header permettant d'identifier le type de bloc  */
/*                    recherche: exemple: "LISTED" ou "LOADED" */
/* RETOUR: long: -1 si echec de la recherche.                          */

long IsThisFuncListInWind(TXTED_OB   *TXT_A, char *path, long lig, char **deb, char **end, char *head)
{long l;
 long l_find = -1;
 char *txt;
 char *fin;
 *deb = 0;
 *end = 0;
 for (l = lig; l<TXT_A->NbLgn; l++)
    {txt = EZ_ED_GETTXT(TXT_A, l, 0);
     if (strncmp(txt, head ,10)==0)   /* expl head: "LISTED"  */
        {if (*deb==0)
            {/*fin  = NextBreakChar(txt + 11, " ");*/ /* se mettre en fin de path */
             fin  =strchr(txt + 13, ':'); /* se mettre en fin de path */
             if (fin==0) return -1;
             while(fin[-1]==' ')fin--;
             *fin = 0;
             if (strcmpi(txt + 11, path )==0)
                {/*.......... eliminer les CR LF avant ......................*/
                 txt -= 2;       /* se mettre avant les \r\n    */
                 *deb = txt;
                 l_find = l;           /* noter la ligne de la trouvaille    */
                }
             *fin = ' ';
            }
         else if (*end==0)
            {/*.......... eliminer les CR LF avant ......................*/
             txt -= 2;       /* se mettre avant les \r\n    */
             *end = txt;
            }
        } /*endif (strncmp(txt, "LOADED" ,10)==0)  */
   } /*endfor (l = 0; l<TXT_A->NbLgn; l++)  */
 if (*deb && *end==0) *end = TXT_A->EndTxt; 
 if (*deb) return l_find;
 else      return -1;
}
 /*---------------- FIndPathOfCurentLineV2 -----------------------*/
 /* ACTION:  partir d'une position dans le texte, retrouve le    */
 /*         path du fichier correspondant.                        */
 /* ENTREE: TXTED_OB   *TXT_A: adresse du composant d'edition qui */
 /*                     contient la liste des fonctions.          */
 /*         char *pt:  caractere pointe dans ce texte a partir    */
 /*                    duquel doit se faire la recherche          */
 /*         char *dst: pointe sur la chaine ou doit etre recopie  */
 /*                    le path trouve. Si cette chaine n'est pas  */
 /*                    vide en entree, alors elle sera consideree */
 /*                    comme un nom de fichier,  ajouter au path */
 /*                    trouv (sera donc enleve le nom avec       */
 /*                            lequel le path aura ete trouve)    */
 /*                    SI dst==0 alors pas de recopie.            */
 /* RETOUR: un pointeur dans le texte d'origine sur le debut du   */
 /*         path trouve   zero si pas de path trouve.             */
/*----------------------- FIndPathOfCurentLineV2 -----------------*/
char *FIndPathOfCurentLineV2(TXTED_OB   *TXT_A, char *pt, char *dst, char *head)
{long l;
 char *txt;
 char sav_end;
 char *lastdeb_path = 0;
 char *lastend_path = 0;
 /*..............  priori dernier path non trouv ...................................*/
 for (l = 0; l<TXT_A->NbLgn; l++)
    {txt = EZ_ED_GETTXT(TXT_A, l, 0);   /* pointer sur debut de ligne                 */
     /*............ si on est sur une ligne de path le noter ........................*/
     if (strncmp(txt, head ,10)==0)
        {lastdeb_path = txt + 11;
         lastend_path = NextBreakChar(txt + 11, " "); /* se mettre en fin de path */
        }
     /*................. si le debut de ligne depasse notre position .................*/
     /*                  courante alors sortir le dernier path rencontre              */
     if (txt>= pt)
        {if (lastdeb_path == 0) return 0;      /* si pas de path avant alors erreur   */
         if (dst)
            {sav_end       = *lastend_path;
             *lastend_path = 0;
             /*............ si la chaine de destination contient un nom ..............*/
             /*             il doit etre place en fin du path trouve                  */
             if (*dst)
                {char *buft = malloc(strlen(dst)+1);
                 if (buft==0)                         /* memoire fail ---> on copie sans merger */
                    {strcpy(dst, lastdeb_path);
                     *lastend_path = sav_end;
                     return lastdeb_path;
                    }
                 else                                 /* enlever nom de fichier et merger       */
                    {strcpy(buft, lastdeb_path);      
                     PathNomToNomFic(buft, 0);        /* virer le nom du path         */
                     strcat(buft, dst);               /* y ajouter  dst               */
                     strcpy(dst, buft);               /* recopier resultat en sortie  */
                     free(buft);
                      *lastend_path = sav_end;
                     return lastdeb_path;
                    }
                }
             /*........... si la chaine de destination est vide ......................*/
             else
                {strcpy(dst, lastdeb_path);
                 *lastend_path = sav_end;
                } 
            }
         return lastdeb_path;
        }
      
   } /*endfor (l = 0; l<TXT_A->NbLgn; l++)  */
 return 0;
}
 /*---------------- FIndPathOfCurentLine -------------------------*/
 /* ACTION:  partir d'une position dans le texte, retrouve le    */
 /*         path du fichier correspondant.                        */
 /* ENTREE: char *deb: premier caractere du texte ou doit se      */
 /*                    faire la recharche. en effet il ne faut    */
 /*                    pas remonter avant .                       */
 /*         char *pt:  caractere pointe dans ce texte a partir    */
 /*                    duquel doit se faire la recherche          */
 /*         char *dst: pointe sur la chaine ou doit etre recopie  */
 /*                    le path trouve. Si cette chaine n'est pas  */
 /*                    vide en entree, alors elle sera consideree */
 /*                    comme un nom de fichier,  ajouter au path */
 /*                    trouv (sera donc enleve le nom avec       */
 /*                            lequel le path aura ete trouve)    */
 /*                    SI dst==0 alors pas de recopie.            */
 /* RETOUR: un pointeur dans le texte d'origine sur le debut du   */
 /*         path trouve   zero si pas de path trouve.             */
 
char *FIndPathOfCurentLine(char *deb, char *pt, char *dst)
{char buft[MAX_PATH];
 if (pt > deb) pt--;
 while (pt > deb && !(*pt == '' && pt[1] == '')) pt--;
 /*..................... on a trouve le debut ....................*/
 if (*pt == '' && pt[1] == '')
    {char *end, sav_end;
     pt       = NextBreakChar(pt, " ");
     pt++;      /* passer l'espace pour pointer au debut du path  */
     if (dst)
        {end      = NextBreakChar(pt+2, " ");
         sav_end  = *end; *end = 0;   /* recuper le path complet  */
         strcpy(buft, pt);
         *end     = sav_end;
         if (*dst)                      /* SI dst n'est pas vide  */
            {PathNomToNomFic(buft, 0);  /* virer le nom du path   */
             strcat(buft, dst);         /* y ajouter  dst         */
            }
         strcpy(dst, buft);
        }
     return pt;
    }
 return 0;
}


/*------------------------ AdjustInfRscToNewGrectWind ------------------------------*/
void AdjustInfRscToNewGrectWind(long w_attr, OBJECT *object, GRECT *oldGrect,  GRECT *newGrect)
{GRECT old_wgrect,new_wgrect;
 int deltx,delty;

 WindGemBorderToEZWork(w_attr, oldGrect, &old_wgrect);
 WindGemBorderToEZWork(w_attr, newGrect, &new_wgrect);

 deltx = new_wgrect.g_w -  old_wgrect.g_w; 
 delty = new_wgrect.g_h -  old_wgrect.g_h;    
 object[EZ_INFO_VERT_BAR].ob_x           += deltx;
 object[EZ_INFO_VERT_UP].ob_x            += deltx;
 object[EZ_INFO_VERT_DOWN].ob_x          += deltx;
 object[EZ_INFO_BULLE_ON_OFF].ob_x       += deltx;
 object[EZ_INFO_BOX].ob_width            += deltx;
 object[EZ_INFO_VERT_DOWN].ob_y          += delty;
 object[EZ_INFO_VERT_BAR].ob_height      += delty;
 object[EZ_INFO_BOX].ob_height           += delty;
 
 object[EZ_INFO_HORZ_BAR].ob_y           += delty;
 object[EZ_INFO_HORZ_LEFT].ob_y          += delty;
 object[EZ_INFO_HORZ_RIGHT].ob_y         += delty;
 object[EZ_INFO_HORZ_RIGHT].ob_x         += deltx;
 object[EZ_INFO_HORZ_BAR].ob_width       += deltx;
}
/*------------------------ AdjustSrollInfoSlide -------------------------*/
void AdjustSrollInfoSlide(OBJECT *object)
{GRECT grect;
 int lgnh, clnw, nbl_view, nbc_view;
 long nb_lgn, nb_cln, fstc, fstl, posh, posv;
              
 GetScrollBoxGRECT( object, EZ_INFO_BOX, &grect, -1);
 GetScrollBoxLParam(object, EZ_INFO_BOX, &lgnh, &clnw, &nb_lgn, &nb_cln, &fstl, &fstc, 0, 0, 0, 0);
 nbl_view = grect.g_h / lgnh;
 nbc_view = grect.g_w / clnw;
 SetSlideWidth(object, EZ_INFO_HORZ_BAR,  nb_cln, nbc_view, fstc, MIN_SLIDE_W, HORIZONTAL); 
 SetSlideWidth(object, EZ_INFO_VERT_BAR,  nb_lgn, nbl_view, fstl, MIN_SLIDE_W, VERTICAL);   
 posh = Min(fstc, nb_cln - nbc_view);
 posv = Min(fstl, nb_lgn - nbl_view);
 DocPosToSlidePos(object,  EZ_INFO_HORZ_BAR, nb_cln, nbc_view, posh, HORIZONTAL);
 DocPosToSlidePos(object,  EZ_INFO_VERT_BAR, nb_lgn, nbl_view, posv, VERTICAL);
 SetScrollBoxParam(object,EZ_INFO_BOX,-2,-2,-2,-2, posv, posh, -2,-2,(void*)-2L,-2);
}
/*----------------------- ActiveInfoWindow -----------------------*/
/* ACTION: ouvre la fenetre manager.                              */
/* ENTREE: func: de 03          N d'onglet  activer = func     */
/*               de 100  103    N d'onglet  activer = func-100 */
/*                               la fenetre ne passe pas au top   */
/*                               et reste en arriere plan.        */
void ActiveInfoWindow(int func)
{int wind;
 int top = 1;
 /*.... si ne pas mettre au top ........*/
 if (func>= 99 && func<=103) 
    {func = func - 100;
     top  = 0;
    }
 wind = IsWindExist(W_EZ_INFO);
 if ( wind != -1 )
    {Windtab[wind].UserPtr = (void*)func;
     if (!IsWindOpen(wind)) OpenWindow(wind, 0);
    
     if (top && GETGEMHAND(wind) != GetTopWind())
        {SendWindMessage(GETGEMHAND(wind), WM_TOPPED, 0);
         ExeAllMessage();
         ExeAllMessage();
        }
    
      ExeWindMessage(wind, WM_INIT_BOOK, 0, 0);
     }
 else 
     {int w_h = CreateWindow (0x8000|SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER|XSIZER|FULLER, 
                               W_EZ_INFO, (void*)func, WindProcEZ_INFO, 0, 0, 0, 0, TxtPtStrMess[WTITLE_DESK] );
      if (w_h==-2 || w_h==-3) form_alert(1,TxtPtStrMess[ALR_NOWIND_MORE]);
     }
}
/*-------------------------- AfficheInfoLigne ---------------------------------*/
int AfficheInfoLigne(long i, int tx, int ty, TXTED_OB *TXT_A)
{ 
#pragma warn -pia   /* Possible incorrect assignment. */
  int d;
  char *affi_buff = TXT_A->AffiBuff;
  char *pt_ini    = 0;        /* caractere affiche */
  char *pt_dst    = affi_buff;
  char *pt_src    = TXT_A->TabLgnCtx[i].ptTxt;
  char sav_c;
  CAR_ATTR *sav;
 if (TXT_A->State & EDIT_HIDE)  return 0;
 /*............ Si edition active et affi de la ligne en edition ............*/
 if (i == TXT_A->LigPt )
    {pt_src = TXT_A->BuffEdit;            /* on affiche le buffer de saisie  */
    }
 else
    {pt_src = TXT_A->TabLgnCtx[i].ptTxt;  /* on affiche le texte normal      */
    }
 pt_ini = pt_src; /* noter Pt de depart de la ligne (pour savoir si 1er car) */
 /*............ positionner les attributs graphiques ........................*/
 vst_alignment (VDIhandle, ALI_LEFT, ALI_BASE, &d, &d);
 tx -= TXT_A->OfsX;
 /*.............. Si numero de ligne positionn .............................*/
 /* 
 if (TXT_A->ATT_Def[ATT_TXT_NUM_LGN].CarCol>-1)
    {TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NUM_LGN];
     TXT_A->DrawTxt(tx+2, ty, ltoa(i+OFSL, "                                ", 10), TXT_A) ;
     TXT_A->ATT_Cur = &TXT_A->ATT_Def[ATT_TXT_NORMAL];
    }
 */
 tx += TXT_A->MargLeft;
 /*............ analyser la ligne ..........................................*/
 while (*pt_src && *pt_src != 13 && *pt_src != 10)
  {if (OngActif==EZ_INFO_ONG_INTDEP)
      {switch(*pt_src)
        {case '"':
         case '<':
             { if (pt_src[-1] == '' || pt_src[-1] == '-')
              /*if (pt_src[-1] == '')*/
                 {char *pt_eol   = EndOfLine(pt_src);
                  sav            = TXT_A->ATT_Cur;
                  sav_c          = *pt_eol; 
                  *pt_eol        = 0;      /* fermer src  pour que strcat fonctionne */
                  *pt_dst        = 0;      /* fermer dest pour que strcat fonctionne */ 
                  pt_dst[-1]     = '-';    /* enlever le symbole de 'deja inclus'    */
                  
                  TXT_A->ATT_Cur  = &ATT_INCL;
                  tx += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
                  if (pt_src[-1] == '')
                     {ATT_INCL.CarEff = 4;    /* Italique   */
                     }
                  else
                     {TXT_A->ATT_Cur = sav;
                     }
                  strcat(pt_dst, pt_src);      /* rajouter reste de la chaine    */
                  tx += TXT_A->DrawTxt( tx,  ty, pt_dst, TXT_A);
                  ATT_INCL.CarEff = 0;
                  *pt_eol         = sav_c;
                  TXT_A->ATT_Cur  = sav;
                  pt_src          = pt_eol;
                  pt_dst          = affi_buff;
                 }
              else
                 {*pt_dst  = *pt_src;
                  pt_dst++;  pt_src++;
                 }
             }
              break;
         case '':
              {char *pt_eol   = EndOfLine(pt_src);
               sav            = TXT_A->ATT_Cur;
               sav_c          = *pt_eol;
                  
               *pt_eol        = 0;
               TXT_A->ATT_Cur = &ATT_HEAD;
               tx += TXT_A->DrawTxt( tx,  ty, pt_src, TXT_A);
               *pt_eol        = sav_c;
               TXT_A->ATT_Cur = sav;
               pt_src         = pt_eol;
               pt_dst         = affi_buff;
              }
              break;
         default:
             {*pt_dst  = *pt_src;
               pt_dst++;  pt_src++;
             }  /* enddefault */
        } /* endswitch */
      }
   else
      {switch(*pt_src)
        {case 9: /*........... si TAB il faut expandre ...................*/
              memset(pt_dst,' ',TXT_A->ExpTAB);
              if (TXT_A->State & EDIT_TAB_VISIBLE)
                 {*pt_dst = TXT_A->CharTAB;
                 } 
              pt_dst[TXT_A->ExpTAB] = 0;
              pt_dst += TXT_A->ExpTAB;
              pt_src++;
              break;
         /*.................. si nom d'une classe l'afficher en bleu ....*/
         case ':':
              if (pt_src[1]==':' && OngActif&(EZ_INFO_ONG_FONCT|EZ_INFO_ONG_LOGOUT))
                 {char      *pt  = pt_dst-1; 
                  sav            = TXT_A->ATT_Cur;
                  while (pt>affi_buff && *pt!=' ')
                        {pt--;
                        }
                  /*... afficher ce qui est avant le nom de la classe... */
                  sav_c          = *pt;   *pt = 0;
                  tx            += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
                  *pt            = sav_c;
                  /*........... afficher le nom de la classe ............*/
                  pt_dst[0]      = ':';
                  pt_dst[1]      = ':';
                  pt_dst[2]      = 0;
                  TXT_A->ATT_Cur = &ATT_CLAS;
                  tx            += TXT_A->DrawTxt( tx,  ty, pt, TXT_A);
                  TXT_A->ATT_Cur = sav;
                  /*........... pointer apres le nom de la classe .....*/
                  pt_src        += 2;
                  pt_dst         = affi_buff;
                 }
              else if (OngActif==EZ_INFO_ONG_LOGOUT)
                 {CAR_ATTR *att = 0;
                  if (strncmp(": In method",pt_src,11)==0)
                     {att = &ATT_METH;
                     }
                  else if (strncmp(": warning:",pt_src,10)==0)
                     {att = &ATT_WARN;
                     }
                  else if (strncmp(": In function",pt_src,13)==0)
                     {att = &ATT_FUNC;
                     }
                  if (att)
                     {char *pt_eol   = EndOfLine(pt_src);
                      sav_c          = *pt_eol;
                      sav            = TXT_A->ATT_Cur;
                  
                      *pt_eol        = 0;
                      TXT_A->ATT_Cur = att;
                      tx += TXT_A->DrawTxt( tx,  ty, pt_src, TXT_A);
                      *pt_eol        = sav_c;
                      TXT_A->ATT_Cur = sav;
                      pt_src         = pt_eol;
                      pt_dst         = affi_buff;
                     }
                 else
                     {*pt_dst  = *pt_src;
                      pt_dst++;  pt_src++;
                     }
                 }
              
              else
                 {*pt_dst  = *pt_src;
                  pt_dst++;  pt_src++;
                 }
              break;
         case '':
              /*...... il faut tester si on est en debut de ligne (pt_src==pt_ini) .....*/
              /*       car il peut y avoir dans le texte affiche apres les found & cie  */
              /*       la serie:   dans l'echantillon affiche.                        */
              if (pt_src[1]=='' && pt_src==pt_ini)
                 {char *pt_eol   = EndOfLine(pt_src);
                  sav_c          = *pt_eol;
                  sav            = TXT_A->ATT_Cur;
                  
                  *pt_eol        = 0;
                  TXT_A->ATT_Cur = &ATT_HEAD;
                  tx += TXT_A->DrawTxt( tx,  ty, pt_src, TXT_A);
                  *pt_eol        = sav_c;
                  TXT_A->ATT_Cur = sav;
                  pt_src         = pt_eol;
                  pt_dst         = affi_buff;
                 }
              else
                 {*pt_dst  = *pt_src;
                  pt_dst++;  pt_src++;
                 }
              break;
         default:
             {*pt_dst  = *pt_src;
               pt_dst++;  pt_src++;
             }  /* enddefault */
        } /* endswitch */
      } /*end else de if (OngActif==EZ_INFO_ONG_INTDEP) */
  }/* endwhile */
 *pt_dst = 0; 
 
 tx += TXT_A->DrawTxt( tx,  ty, affi_buff, TXT_A);
 /*............. si couleur fin de ligne positionne .................*/
 if (TXT_A->ATT_Def[ATT_TXT_EOL].CarCol>-1)
    {int EOF_COL[2] = {2,0};
     EOF_COL[0]     = TXT_A->ATT_Def[ATT_TXT_EOL].CarCol; 
     Put_mono_color(tx, ty + TXT_A->IntLg - IC_EOF[1]-1,IC_EOF,2,EOF_COL);
    }
 /*................ si curseur positionne ...........................*/
 if ( TXT_A->CurState && i==TXT_A->LigPt )
    {EZ_ED_PaintCurs(TXT_A);
    }
 /*.............. si un bloc est positionn .........................*/
 if (TXT_A->BlkEndLig != TXT_A->BlkDebLig || TXT_A->BlkEndCar != TXT_A->BlkDebCar)
    {long blk_first = TXT_A->BlkDebLig;
     long blk_last  = TXT_A->BlkEndLig;
     /*.... le debut et fin de ligne de bloc peuvent etre inverses ...*/
     /*           donc les remettre en ordre pour test                */
     if (blk_last < blk_first)
        {blk_first = TXT_A->BlkEndLig;
         blk_last  = TXT_A->BlkDebLig;
        }
      
     /*......... tester si la ligne en cours d'affichage est .........*/
     /*                    dans le bloc                               */
     if (i>= blk_first && i<= blk_last)
        {/*............ afficher le  bloc ............................*/
         EZ_ED_DrawBlkFrame(i, BLK_LINE_DRAW, TXT_A);
        }
    }
 return 1;
#pragma warn .pia
}

/*----------------------------- OnMouseErreur ------------------------------*/
INT16 OnMouseErreur(TXTED_OB  *TXT_A,  EVNT_O *Evnt)
{long x             = Evnt->x;
 long y             = Evnt->y;
 char *txt          = 0;
 INT16 wind         = IsWindExist(CurIDDoc);
 
 if (!IsMouseXYInGrect((INT16)x, (INT16)y, &TXT_A->TxtGrect)) return -2;
 if (TXT_A->State & MO_TRACK_ON)                              return -1;
 txt         = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_A);
 /*...... stocker ancienne postion avant saut ............*/
 if (wind>-1 && IS_IDWINDTXT(CurIDDoc)) 
    {TXTED_OB*  TXT_O  = WTXT_A(wind);
     TXT_GFG* ptTxtCfg = WTXT_CFG(wind);
     LastHelpPos       = EZ_ED_GETCURPOS(TXT_O);
     strcpy( LastHelpFic, ptTxtCfg->PathTxt);
     strcat( LastHelpFic, ptTxtCfg->NomTxt );
    }
 
 if (OngActif==EZ_INFO_ONG_INTDEP)
    {if (Evnt->click == 2)
         ActiveDependList(TXT_A, Evnt->x, Evnt->y, GOTO_OPENWIND|SET_TO_TOP);
     else
         ActiveDependList(TXT_A, Evnt->x, Evnt->y, 0);
    }
 else
    {if (Evnt->click == 2)
         ActiveMessList(PathIndex, TXT_A->ptTxt, txt, GOTO_OPENWIND|SET_TO_TOP);
     else
         ActiveMessList(PathIndex, TXT_A->ptTxt, txt, 0);
    }
 Mouse_on();
 return 1;
}


